//-------------------------------------------------------------------------
// Copyright (c) 1999 Steven Freyder, David Helland, Bruce D. Lightner and
// Lightner Engineering.  Use subject to licensing restrictions described
// the file LICENSE.txt.  If you do not agree with the licensing terms then
// you must return and/or destroy this software immediately!
//-------------------------------------------------------------------------

/************************************************************************/
/*
 * this is the canonical command port used by the various batch files
 * which invoke the debugger via the 'net.  if you don't have DEBUGGER
 * defined, then it doesn't matter because there won't be any command
 * interpreter to run the commands anyway.  Unless of course your code
 * has some special conditionals which don't depend on the DEBUGGER
 * symbol...
 */
#ifndef TCPPORT_CMD
#define TCPPORT_CMD 911
#endif

/*
 * if you want URLs in FLASH, then define the following symbol, but for
 * most implementations, leave it alone.  most everybody wants their URLs
 * in serial EEPROM...
 */
//#define URL_IN_FLASH

/*
 * this is the base of the CGI index table in serial EEPROM (SEEPROM).
 */
#ifndef CGI_INDEX_BASE
#define CGI_INDEX_BASE  0x3800  /* SEEPROM base of CGI index */
#endif

#ifndef SER_EEPROM_BASE_ADDR
#define SER_EEPROM_BASE_ADDR    0xA0	/* 24LC128 128K-bit serial EEPROM */
#endif

/*
 * define this if you don't want verification of your ether address on
 * boot.
 */
//#define NO_ETHER_ADDR_ON_BOOT

/*
 * idle network packet watchdog timer limit (range: 100-254 loop counts)
 */
#ifndef PKT_WATCHDOG_MAX
#define PKT_WATCHDOG_MAX    250
#endif

/*
 * default bootup banner sent to serial port
 */
#ifndef BANNER
#define BANNER "\r\nPicoWeb Server\r\n"
#endif

/*
 * default serial port baud rate clock divisor
 *
 *               - Processor  -
 *   Baud Rate   - Clock Rate -
 *    Divisor    8 MHz    4 MHz
 *    -------    -----    -----
 *       25      19200     9600
 *       51       9600     4800
 *      103       4800     2400
 *      207       2400     1200
 */
#ifndef SERIAL_BAUD_DIVISOR
#define SERIAL_BAUD_DIVISOR 25
#endif

/************************************************************************/
