;-------------------------------------------------------------------------
; Copyright (c) 1999 Steven Freyder, David Helland, Bruce D. Lightner and
; Lightner Engineering.  Use subject to licensing restrictions described
; the file LICENSE.txt.  If you do not agree with the licensing terms then
; you must return and/or destroy this software immediately!
;-------------------------------------------------------------------------
;
; code to handle the getting/setting of the PicoWeb IP address
;

getip:

#if defined(STATIC_IP_MSB)
    movwi x,my_ip        ; hard code IP address
    movwi x,my_ip
    movwi y,STATIC_IP_MSB
    st x+,yh
    st x+,yl
    movwi y,STATIC_IP_LSB
    st x+,yh
    st x+,yl

#else /* !STATIC_IP_MSB */

#if defined(EEPROM_IP)
    movwi x,my_ip	  ; get IP address from on-chip eeprom
    ldi r18l,4            ; move 4 bytes
    movwi y,eeprom_ip_addr
    rcall ee2s

.eseg
eeprom_ip_addr:            ; onboard storage for IP address
#include "ip.inc"
.cseg

#else /* !EEPROM_IP */

#if defined(SEEPROM_IP)
    movwi x,my_ip         ; get IP address from external SEEPROM
    ldi r18l,4            ; move 4 bytes
    movwi y,SEEPROM_IP
    rcall see2s

#else /* !SEEPROM_IP */

#if defined(USE_BOOTP)
    movwi x,my_ip         ; use BOOTP
    ldi r18l,4            ; zero 4 bytes
    clr r0
bootp_zeroip:
    st x+,r0
    dec r18l
    brne bootp_zeroip

#else /* !USE_BOOTP */

#error "define USE_BOOTP, SEEPROM_IP, EEPROM_IP, or STATIC_IP_MSB"

#endif /* !USE_BOOTP */
#endif /* !SEEPROM_IP */
#endif /* !EEPROM_IP */
#endif /* !STATIC_IP_MSB */
    ret

#include "bootp.asm"
