;---------------------------------------  
; LIGHTNER ENGINEERING PROPRIETARY DATA   
;---------------------------------------  
;-------------------------------------------------------------------------
; Copyright (c) 1999 Steven Freyder, David Helland, Bruce D. Lightner and
; Lightner Engineering.  Use subject to licensing restrictions described
; in "PICOWEB SERVER SOFTWARE LICENSE AGREEMENT DATED JULY 14, 1999"
; (See file LICENSE.txt).  If you do not agree with the licensing terms
; then you must return and/or destroy this software immediately!
;-------------------------------------------------------------------------
#define VERSION "1.38"
#define BREADBOARD
#define LED_BIT 2             
;
; these are interrupt service routine stubs for the unused interrupt
; vectors.  If you want to service one of these interrupts, you should
; supply an interrupt service routine and supply a define in "userdef.h"
; for that interrupt.  For example, to supply an interrupt service routine
; called "int0_isr", add the define "#define USER_int0_isr int0_isr" and
; include the needed firmware as part of the build process.

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; This code MUST BE exactly 13 words long!!!
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; 
; interrupt vector table
;
    rjmp reset
#ifndef USER_int0_isr
    rjmp default_isr
#else
    rjmp USER_int0_isr
#endif
#ifndef USER_int1_isr
    rjmp default_isr
#else
    rjmp USER_int1_isr
#endif
#ifndef USER_timer1cap_isr
    rjmp default_isr
#else
    rjmp USER_timer1cap_isr
#endif
#ifndef USER_timer1compa_isr
    rjmp default_isr
#else
    rjmp USER_timer1compa_isr
#endif
#ifndef USER_timer1compb_isr
    rjmp default_isr
#else
    rjmp USER_timer1compb_isr
#endif
#ifndef USER_timer1ovf_isr
    rjmp default_isr
#else
    rjmp USER_timer1ovf_isr
#endif
#ifndef USER_timer0ovf_isr
    rjmp default_isr
#else
    rjmp USER_timer0ovf_isr
#endif
#ifndef USER_spistc_isr
    rjmp default_isr
#else
    rjmp USER_spistc_isr
#endif
#ifndef USER_rx_isr
    rjmp rx_isr      ; PicoWeb serial port receive interrupt handler
#else
    rjmp USER_rx_isr
#endif
#ifndef USER_udre_isr
    rjmp default_isr
#else
    rjmp USER_udre_isr
#endif
#ifndef USER_tx_isr
    rjmp default_isr
#else
    rjmp USER_tx_isr
#endif
#ifndef USER_ana_comp_isr
    rjmp default_isr
#else
    rjmp USER_ana_comp_isr
#endif
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; This code MUST BE exactly 13 words long!!!
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

.dw 0x9508 ;000D
.dw 0x2400 ;000E
.dw 0x9200 ;000F
.dw 0x0128 ;0010
.dw 0x9200 ;0011
.dw 0x0129 ;0012
.dw 0xD02B ;0013
.dw 0xC0EC ;0014
.dw 0x931F ;0015
.dw 0xE610 ;0016
.dw 0x2B10 ;0017
.dw 0xBB15 ;0018
.dw 0xEF1F ;0019
.dw 0xBB1A ;001A
.dw 0xBB17 ;001B
.dw 0xBA2B ;001C
.dw 0xBA38 ;001D
.dw 0xE210 ;001E
.dw 0x2B10 ;001F
.dw 0xBB15 ;0020
.dw 0x0000 ;0021
.dw 0x0000 ;0022
.dw 0x0000 ;0023
.dw 0x0000 ;0024
.dw 0xE610 ;0025
.dw 0x2B10 ;0026
.dw 0xBB15 ;0027
.dw 0x911F ;0028
.dw 0x9508 ;0029
.dw 0x931F ;002A
.dw 0x2711 ;002B
.dw 0xBB1A ;002C
.dw 0xBB17 ;002D
.dw 0xE610 ;002E
.dw 0x2B10 ;002F
.dw 0xBB15 ;0030
.dw 0xE410 ;0031
.dw 0x2B10 ;0032
.dw 0xBB15 ;0033
.dw 0x0000 ;0034
.dw 0x0000 ;0035
.dw 0x0000 ;0036
.dw 0x0000 ;0037
.dw 0xE610 ;0038
.dw 0x2B10 ;0039
.dw 0xB229 ;003A
.dw 0xB236 ;003B
.dw 0xBB15 ;003C
.dw 0x911F ;003D
.dw 0x9508 ;003E
.dw 0xEF0F ;003F
.dw 0xBB04 ;0040
.dw 0x2700 ;0041
.dw 0xBB0A ;0042
.dw 0xBB07 ;0043
.dw 0xEE00 ;0044
.dw 0xBB05 ;0045
.dw 0xD004 ;0046
.dw 0xE600 ;0047
.dw 0xBB05 ;0048
.dw 0xD001 ;0049
.dw 0x9508 ;004A
.dw 0x930F ;004B
.dw 0x931F ;004C
.dw 0x2700 ;004D
.dw 0x2711 ;004E
.dw 0x951A ;004F
.dw 0xF7F1 ;0050
.dw 0x950A ;0051
.dw 0xF7D9 ;0052
.dw 0x911F ;0053
.dw 0x910F ;0054
.dw 0x9508 ;0055
.dw 0xE007 ;0056
.dw 0xDFD2 ;0057
.dw 0x2822 ;0058
.dw 0xF009 ;0059
.dw 0xD183 ;005A
.dw 0x9508 ;005B
.dw 0xE00B ;005C
.dw 0x2E23 ;005D
.dw 0xDFB6 ;005E
.dw 0xE00A ;005F
.dw 0x2E22 ;0060
.dw 0xDFB3 ;0061
.dw 0x9508 ;0062
.dw 0x930F ;0063
.dw 0x922F ;0064
.dw 0xE202 ;0065
.dw 0x2E20 ;0066
.dw 0xE000 ;0067
.dw 0xDFAC ;0068
.dw 0xDFF2 ;0069
.dw 0xD04C ;006A
.dw 0xE00A ;006B
.dw 0x2E20 ;006C
.dw 0xE000 ;006D
.dw 0xDFA6 ;006E
.dw 0x2700 ;006F
.dw 0xBB0A ;0070
.dw 0xBB07 ;0071
.dw 0xE700 ;0072
.dw 0xBB05 ;0073
.dw 0x0000 ;0074
.dw 0xE500 ;0075
.dw 0xBB05 ;0076
.dw 0x0000 ;0077
.dw 0x0000 ;0078
.dw 0x0000 ;0079
.dw 0x0000 ;007A
.dw 0xE700 ;007B
.dw 0x0000 ;007C
.dw 0xB229 ;007D
.dw 0xB236 ;007E
.dw 0xBB05 ;007F
.dw 0x9509 ;0080
.dw 0x5021 ;0081
.dw 0x4030 ;0082
.dw 0x5021 ;0083
.dw 0x4030 ;0084
.dw 0xF008 ;0085
.dw 0xF771 ;0086
.dw 0x902F ;0087
.dw 0x910F ;0088
.dw 0x9508 ;0089
.dw 0x930F ;008A
.dw 0x922F ;008B
.dw 0xD019 ;008C
.dw 0xE700 ;008D
.dw 0xBB05 ;008E
.dw 0xEF0F ;008F
.dw 0xBB0A ;0090
.dw 0xBB07 ;0091
.dw 0x9509 ;0092
.dw 0xBA2B ;0093
.dw 0xBA38 ;0094
.dw 0xE300 ;0095
.dw 0xBB05 ;0096
.dw 0x0000 ;0097
.dw 0x0000 ;0098
.dw 0x0000 ;0099
.dw 0x0000 ;009A
.dw 0xE700 ;009B
.dw 0xBB05 ;009C
.dw 0x5021 ;009D
.dw 0x4030 ;009E
.dw 0x5021 ;009F
.dw 0x4030 ;00A0
.dw 0xF008 ;00A1
.dw 0xF779 ;00A2
.dw 0x902F ;00A3
.dw 0x910F ;00A4
.dw 0x9508 ;00A5
.dw 0xE202 ;00A6
.dw 0x2E20 ;00A7
.dw 0xE000 ;00A8
.dw 0xDF6B ;00A9
.dw 0xE005 ;00AA
.dw 0x2E22 ;00AB
.dw 0xDF68 ;00AC
.dw 0xE006 ;00AD
.dw 0x2E23 ;00AE
.dw 0xDF65 ;00AF
.dw 0xDFAB ;00B0
.dw 0xD005 ;00B1
.dw 0xE102 ;00B2
.dw 0x2E20 ;00B3
.dw 0xE000 ;00B4
.dw 0xDF5F ;00B5
.dw 0x9508 ;00B6
.dw 0xE009 ;00B7
.dw 0x2E25 ;00B8
.dw 0xDF5B ;00B9
.dw 0xE008 ;00BA
.dw 0x2E24 ;00BB
.dw 0x2E35 ;00BC
.dw 0xDF57 ;00BD
.dw 0x9508 ;00BE
.dw 0x332C ;00BF
.dw 0xE090 ;00C0
.dw 0x0739 ;00C1
.dw 0xF414 ;00C2
.dw 0xE32C ;00C3
.dw 0xE030 ;00C4
.dw 0xE006 ;00C5
.dw 0x2E23 ;00C6
.dw 0xDF4D ;00C7
.dw 0xE005 ;00C8
.dw 0x2E22 ;00C9
.dw 0xDF4A ;00CA
.dw 0xE004 ;00CB
.dw 0x2E25 ;00CC
.dw 0xDF47 ;00CD
.dw 0xE206 ;00CE
.dw 0x2E20 ;00CF
.dw 0xE000 ;00D0
.dw 0xDF43 ;00D1
.dw 0xE007 ;00D2
.dw 0xDF56 ;00D3
.dw 0xE09A ;00D4
.dw 0x2192 ;00D5
.dw 0xF3E1 ;00D6
.dw 0xE098 ;00D7
.dw 0x2192 ;00D8
.dw 0xF019 ;00D9
.dw 0xD650 ;00DA
.dw 0x1060 ;00DB
.dw 0xD613 ;00DC
.dw 0xE00A ;00DD
.dw 0x2E20 ;00DE
.dw 0xE007 ;00DF
.dw 0xDF34 ;00E0
.dw 0x9508 ;00E1
.dw 0xE10F ;00E2
.dw 0xDF46 ;00E3
.dw 0xD07C ;00E4
.dw 0xDF2F ;00E5
.dw 0xE201 ;00E6
.dw 0x2E20 ;00E7
.dw 0xE000 ;00E8
.dw 0xDF2B ;00E9
.dw 0xD076 ;00EA
.dw 0x9508 ;00EB
.dw 0xE409 ;00EC
.dw 0x2E20 ;00ED
.dw 0xE00E ;00EE
.dw 0xDF25 ;00EF
.dw 0xE02C ;00F0
.dw 0xE030 ;00F1
.dw 0x2744 ;00F2
.dw 0x2755 ;00F3
.dw 0xE6A4 ;00F4
.dw 0xE0B0 ;00F5
.dw 0xEFEA ;00F6
.dw 0xE0F0 ;00F7
.dw 0xDF6A ;00F8
.dw 0x9508 ;00F9
.dw 0x922D ;00FA
.dw 0x9508 ;00FB
.dw 0xE201 ;00FC
.dw 0x2E20 ;00FD
.dw 0xE000 ;00FE
.dw 0xDF15 ;00FF
.dw 0x9508 ;0100
.dw 0xE410 ;0101
.dw 0x9310 ;0102
.dw 0x012A ;0103
.dw 0xE600 ;0104
.dw 0x9300 ;0105
.dw 0x0103 ;0106
.dw 0xDFDA ;0107
.dw 0x2722 ;0108
.dw 0x2733 ;0109
.dw 0xDF51 ;010A
.dw 0xE200 ;010B
.dw 0x2E20 ;010C
.dw 0xE00C ;010D
.dw 0xDF06 ;010E
.dw 0xE002 ;010F
.dw 0x2E20 ;0110
.dw 0xE00D ;0111
.dw 0xDF02 ;0112
.dw 0xDFD8 ;0113
.dw 0xE200 ;0114
.dw 0x2E20 ;0115
.dw 0xE000 ;0116
.dw 0xDEFD ;0117
.dw 0xE406 ;0118
.dw 0x2E20 ;0119
.dw 0xE001 ;011A
.dw 0xDEF9 ;011B
.dw 0xE003 ;011C
.dw 0xDEF7 ;011D
.dw 0xE002 ;011E
.dw 0x9020 ;011F
.dw 0x0103 ;0120
.dw 0xDEF3 ;0121
.dw 0xEF0F ;0122
.dw 0x2E20 ;0123
.dw 0xE007 ;0124
.dw 0xDEEF ;0125
.dw 0xE000 ;0126
.dw 0x2E20 ;0127
.dw 0xE00F ;0128
.dw 0xDEEB ;0129
.dw 0xE600 ;012A
.dw 0x2E20 ;012B
.dw 0xE000 ;012C
.dw 0xDEE7 ;012D
.dw 0xE001 ;012E
.dw 0xE016 ;012F
.dw 0xE6A4 ;0130
.dw 0xE0B0 ;0131
.dw 0x902D ;0132
.dw 0xDEE1 ;0133
.dw 0x9503 ;0134
.dw 0x951A ;0135
.dw 0xF7D9 ;0136
.dw 0xE601 ;0137
.dw 0x2E20 ;0138
.dw 0xE000 ;0139
.dw 0xDEDA ;013A
.dw 0xEF0F ;013B
.dw 0x2E20 ;013C
.dw 0xE008 ;013D
.dw 0xE018 ;013E
.dw 0xDED5 ;013F
.dw 0x9503 ;0140
.dw 0x951A ;0141
.dw 0xF7E1 ;0142
.dw 0xE202 ;0143
.dw 0x2E20 ;0144
.dw 0xE000 ;0145
.dw 0xDECE ;0146
.dw 0xE601 ;0147
.dw 0x2E20 ;0148
.dw 0xE000 ;0149
.dw 0xDECA ;014A
.dw 0xE417 ;014B
.dw 0x9310 ;014C
.dw 0x0101 ;014D
.dw 0x9310 ;014E
.dw 0x0102 ;014F
.dw 0x2E21 ;0150
.dw 0xE007 ;0151
.dw 0xDEC2 ;0152
.dw 0xE202 ;0153
.dw 0x2E20 ;0154
.dw 0xE000 ;0155
.dw 0xDEBE ;0156
.dw 0xE000 ;0157
.dw 0x2E20 ;0158
.dw 0xE00D ;0159
.dw 0xDEBA ;015A
.dw 0xE004 ;015B
.dw 0x2E20 ;015C
.dw 0xE00C ;015D
.dw 0xDEB6 ;015E
.dw 0x9508 ;015F
.dw 0x0000 ;0160
.dw 0x931F ;0161
.dw 0x930F ;0162
.dw 0xEF04 ;0163
.dw 0xE011 ;0164
.dw 0x5001 ;0165
.dw 0x4010 ;0166
.dw 0xF7E9 ;0167
.dw 0x910F ;0168
.dw 0x911F ;0169
.dw 0x9508 ;016A
.dw 0xE122 ;016B
.dw 0xE030 ;016C
.dw 0xE0A7 ;016D
.dw 0xE0B1 ;016E
.dw 0xE7E3 ;016F
.dw 0xE0F1 ;0170
.dw 0xDEF1 ;0171
.dw 0x9508 ;0172
.dw 0x922D ;0173
.dw 0x923D ;0174
.dw 0x9508 ;0175
.dw 0xE000 ;0176
.dw 0xDEB2 ;0177
.dw 0x2D12 ;0178
.dw 0x9100 ;0179
.dw 0x0103 ;017A
.dw 0x5406 ;017B
.dw 0x9300 ;017C
.dw 0x0106 ;017D
.dw 0xE201 ;017E
.dw 0x2E20 ;017F
.dw 0xE000 ;0180
.dw 0xDE93 ;0181
.dw 0xDFDE ;0182
.dw 0x2722 ;0183
.dw 0x2733 ;0184
.dw 0xDED6 ;0185
.dw 0xE002 ;0186
.dw 0x2E20 ;0187
.dw 0xE00D ;0188
.dw 0xDE8B ;0189
.dw 0xE202 ;018A
.dw 0x2E20 ;018B
.dw 0xE000 ;018C
.dw 0xDE87 ;018D
.dw 0xE600 ;018E
.dw 0x2E20 ;018F
.dw 0xE000 ;0190
.dw 0xDE83 ;0191
.dw 0xE007 ;0192
.dw 0xDE96 ;0193
.dw 0x2D62 ;0194
.dw 0xE200 ;0195
.dw 0x2E20 ;0196
.dw 0xE000 ;0197
.dw 0xDE7C ;0198
.dw 0x9020 ;0199
.dw 0x0101 ;019A
.dw 0x1626 ;019B
.dw 0xF409 ;019C
.dw 0xC021 ;019D
.dw 0x2F56 ;019E
.dw 0x2744 ;019F
.dw 0xDFCA ;01A0
.dw 0x9110 ;01A1
.dw 0x0107 ;01A2
.dw 0xE091 ;01A3
.dw 0x2391 ;01A4
.dw 0xF0A1 ;01A5
.dw 0x9110 ;01A6
.dw 0x0106 ;01A7
.dw 0x951A ;01A8
.dw 0xF080 ;01A9
.dw 0x9310 ;01AA
.dw 0x0106 ;01AB
.dw 0x9110 ;01AC
.dw 0x0108 ;01AD
.dw 0x3416 ;01AE
.dw 0xF050 ;01AF
.dw 0x9100 ;01B0
.dw 0x0103 ;01B1
.dw 0x1710 ;01B2
.dw 0xF430 ;01B3
.dw 0x9310 ;01B4
.dw 0x0101 ;01B5
.dw 0x9360 ;01B6
.dw 0x0105 ;01B7
.dw 0xD07B ;01B8
.dw 0xC003 ;01B9
.dw 0xDE84 ;01BA
.dw 0xDF45 ;01BB
.dw 0xC013 ;01BC
.dw 0x9160 ;01BD
.dw 0x0101 ;01BE
.dw 0x956A ;01BF
.dw 0x3466 ;01C0
.dw 0xF41C ;01C1
.dw 0x9160 ;01C2
.dw 0x0103 ;01C3
.dw 0x956A ;01C4
.dw 0xE003 ;01C5
.dw 0x2E26 ;01C6
.dw 0xDE4D ;01C7
.dw 0xE100 ;01C8
.dw 0x2E20 ;01C9
.dw 0xE007 ;01CA
.dw 0xDE49 ;01CB
.dw 0xE000 ;01CC
.dw 0x2E20 ;01CD
.dw 0xE00D ;01CE
.dw 0xDE45 ;01CF
.dw 0x9508 ;01D0
.dw 0x931F ;01D1
.dw 0xE00D ;01D2
.dw 0xE013 ;01D3
.dw 0xDE55 ;01D4
.dw 0x9503 ;01D5
.dw 0x951A ;01D6
.dw 0xF7E1 ;01D7
.dw 0xE200 ;01D8
.dw 0x2E20 ;01D9
.dw 0xE007 ;01DA
.dw 0xDE39 ;01DB
.dw 0x911F ;01DC
.dw 0x9508 ;01DD
.dw 0x2D12 ;01DE
.dw 0xE190 ;01DF
.dw 0x2391 ;01E0
.dw 0xF011 ;01E1
.dw 0xDF93 ;01E2
.dw 0xC04B ;01E3
.dw 0xE290 ;01E4
.dw 0x2391 ;01E5
.dw 0xF009 ;01E6
.dw 0xDFE9 ;01E7
.dw 0xE095 ;01E8
.dw 0x2391 ;01E9
.dw 0xF409 ;01EA
.dw 0xC043 ;01EB
.dw 0xE094 ;01EC
.dw 0x2391 ;01ED
.dw 0xF001 ;01EE
.dw 0xE005 ;01EF
.dw 0x2E20 ;01F0
.dw 0xE007 ;01F1
.dw 0xDE22 ;01F2
.dw 0xE602 ;01F3
.dw 0x2E20 ;01F4
.dw 0xE000 ;01F5
.dw 0xDE1E ;01F6
.dw 0xE007 ;01F7
.dw 0xDE31 ;01F8
.dw 0x9220 ;01F9
.dw 0x0102 ;01FA
.dw 0xE202 ;01FB
.dw 0x2E20 ;01FC
.dw 0xE000 ;01FD
.dw 0xDE16 ;01FE
.dw 0x9150 ;01FF
.dw 0x0101 ;0200
.dw 0x9110 ;0201
.dw 0x0102 ;0202
.dw 0x1751 ;0203
.dw 0xF0E1 ;0204
.dw 0x2744 ;0205
.dw 0xDF64 ;0206
.dw 0x9140 ;0207
.dw 0x0107 ;0208
.dw 0x3041 ;0209
.dw 0xF011 ;020A
.dw 0x3241 ;020B
.dw 0xF481 ;020C
.dw 0x9110 ;020D
.dw 0x0108 ;020E
.dw 0x9310 ;020F
.dw 0x0101 ;0210
.dw 0x3416 ;0211
.dw 0xF050 ;0212
.dw 0x9350 ;0213
.dw 0x0105 ;0214
.dw 0xD01E ;0215
.dw 0x9120 ;0216
.dw 0x0103 ;0217
.dw 0x9110 ;0218
.dw 0x0101 ;0219
.dw 0x1712 ;021A
.dw 0xF408 ;021B
.dw 0xC005 ;021C
.dw 0x9110 ;021D
.dw 0x0102 ;021E
.dw 0x9310 ;021F
.dw 0x0101 ;0220
.dw 0xC00D ;0221
.dw 0x9110 ;0222
.dw 0x0101 ;0223
.dw 0x951A ;0224
.dw 0x3416 ;0225
.dw 0xF418 ;0226
.dw 0x9110 ;0227
.dw 0x0103 ;0228
.dw 0x951A ;0229
.dw 0xE003 ;022A
.dw 0x2E21 ;022B
.dw 0x2C32 ;022C
.dw 0xDDE7 ;022D
.dw 0xCFD0 ;022E
.dw 0xE400 ;022F
.dw 0x2E20 ;0230
.dw 0xE007 ;0231
.dw 0xDDE2 ;0232
.dw 0x9508 ;0233
.dw 0xD549 ;0234
.dw 0x05E6 ;0235
.dw 0x0117 ;0236
.dw 0x0608 ;0237
.dw 0x053F ;0238
.dw 0x0241 ;0239
.dw 0x05E6 ;023A
.dw 0x0117 ;023B
.dw 0x0008 ;023C
.dw 0x053F ;023D
.dw 0x0271 ;023E
.dw 0x0000 ;023F
.dw 0x9508 ;0240
.dw 0x04F9 ;0241
.dw 0x00B0 ;0242
.dw 0x0026 ;0243
.dw 0x0004 ;0244
.dw 0x050A ;0245
.dw 0x00B0 ;0246
.dw 0x0060 ;0247
.dw 0x0004 ;0248
.dw 0x053B ;0249
.dw 0x026F ;024A
.dw 0x05FE ;024B
.dw 0x0128 ;024C
.dw 0x0001 ;024D
.dw 0x0568 ;024E
.dw 0x0000 ;024F
.dw 0x0006 ;0250
.dw 0x0006 ;0251
.dw 0x054F ;0252
.dw 0x0006 ;0253
.dw 0x0064 ;0254
.dw 0x0006 ;0255
.dw 0x0568 ;0256
.dw 0x000C ;0257
.dw 0x000C ;0258
.dw 0x0008 ;0259
.dw 0x0547 ;025A
.dw 0x0014 ;025B
.dw 0x0200 ;025C
.dw 0x054F ;025D
.dw 0x0016 ;025E
.dw 0x0064 ;025F
.dw 0x0006 ;0260
.dw 0x0568 ;0261
.dw 0x001C ;0262
.dw 0x0026 ;0263
.dw 0x0004 ;0264
.dw 0x0568 ;0265
.dw 0x0020 ;0266
.dw 0x0016 ;0267
.dw 0x0006 ;0268
.dw 0x0568 ;0269
.dw 0x0026 ;026A
.dw 0x001C ;026B
.dw 0x0004 ;026C
.dw 0x05BF ;026D
.dw 0x002A ;026E
.dw 0x0000 ;026F
.dw 0x9508 ;0270
.dw 0x04F9 ;0271
.dw 0x00B0 ;0272
.dw 0x001E ;0273
.dw 0x0004 ;0274
.dw 0x050A ;0275
.dw 0x00B0 ;0276
.dw 0x0060 ;0277
.dw 0x0004 ;0278
.dw 0x053B ;0279
.dw 0x0292 ;027A
.dw 0x04F9 ;027B
.dw 0x00B0 ;027C
.dw 0x0016 ;027D
.dw 0x0002 ;027E
.dw 0x05EB ;027F
.dw 0x00B1 ;0280
.dw 0x0001 ;0281
.dw 0x053F ;0282
.dw 0x0296 ;0283
.dw 0x05EB ;0284
.dw 0x00B1 ;0285
.dw 0x0006 ;0286
.dw 0x053F ;0287
.dw 0x0338 ;0288
.dw 0x05EB ;0289
.dw 0x00B1 ;028A
.dw 0x0011 ;028B
.dw 0x053F ;028C
.dw 0x0290 ;028D
.dw 0x0000 ;028E
.dw 0x9508 ;028F
.dw 0x0000 ;0290
rjmp import_udp
.dw 0x0000 ;0292
rjmp import_unknown_ipaddr
.dw 0x0000 ;0294
.dw 0x9508 ;0295
.dw 0x8568 ;0296
.dw 0x0000 ;0297
.dw 0x0000 ;0298
.dw 0xC109 ;0299
.dw 0x04F9 ;029A
.dw 0x00B0 ;029B
.dw 0x0010 ;029C
.dw 0x0002 ;029D
.dw 0x076B ;029E
.dw 0x02F7 ;029F
.dw 0x861B ;02A0
.dw 0x00B0 ;02A1
.dw 0xE0B0 ;02A2
.dw 0x0547 ;02A3
.dw 0x0022 ;02A4
.dw 0x0000 ;02A5
.dw 0x0547 ;02A6
.dw 0x0024 ;02A7
.dw 0x0000 ;02A8
.dw 0x0616 ;02A9
.dw 0x0119 ;02AA
.dw 0x861B ;02AB
.dw 0x011B ;02AC
.dw 0xC0B0 ;02AD
.dw 0x05F9 ;02AE
.dw 0x011B ;02AF
.dw 0x0014 ;02B0
.dw 0x0624 ;02B1
.dw 0x011E ;02B2
.dw 0x012A ;02B3
.dw 0x061F ;02B4
.dw 0x011D ;02B5
.dw 0x0022 ;02B6
.dw 0x0647 ;02B7
.dw 0x05D1 ;02B8
.dw 0x0119 ;02B9
.dw 0xFFFF ;02BA
.dw 0x8547 ;02BB
.dw 0x0024 ;02BC
.dw 0xC119 ;02BD
.dw 0x85BF ;02BE
.dw 0xC109 ;02BF
.dw 0x0000 ;02C0
.dw 0x9508 ;02C1
.dw 0x04F5 ;02C2
.dw 0x010B ;02C3
.dw 0x001A ;02C4
.dw 0x0004 ;02C5
.dw 0x04F5 ;02C6
.dw 0x010F ;02C7
.dw 0x001E ;02C8
.dw 0x0004 ;02C9
.dw 0x04F5 ;02CA
.dw 0x0113 ;02CB
.dw 0x0016 ;02CC
.dw 0x0002 ;02CD
.dw 0x061F ;02CE
.dw 0x0113 ;02CF
.dw 0x0000 ;02D0
.dw 0x04F5 ;02D1
.dw 0x011B ;02D2
.dw 0x0010 ;02D3
.dw 0x0002 ;02D4
.dw 0x861B ;02D5
.dw 0x011B ;02D6
.dw 0xE11B ;02D7
.dw 0x05F9 ;02D8
.dw 0x011B ;02D9
.dw 0x0014 ;02DA
.dw 0x861B ;02DB
.dw 0x0115 ;02DC
.dw 0xE11B ;02DD
.dw 0x0616 ;02DE
.dw 0x0119 ;02DF
.dw 0x0624 ;02E0
.dw 0x011E ;02E1
.dw 0x012A ;02E2
.dw 0x061F ;02E3
.dw 0x011D ;02E4
.dw 0x0022 ;02E5
.dw 0x0647 ;02E6
.dw 0x861B ;02E7
.dw 0x0117 ;02E8
.dw 0xC119 ;02E9
.dw 0x0616 ;02EA
.dw 0x0119 ;02EB
.dw 0x061B ;02EC
.dw 0x011D ;02ED
.dw 0x010B ;02EE
.dw 0x061B ;02EF
.dw 0x011B ;02F0
.dw 0x000E ;02F1
.dw 0x0637 ;02F2
.dw 0x05D1 ;02F3
.dw 0x0119 ;02F4
.dw 0xFFFF ;02F5
.dw 0x075D ;02F6
.dw 0x0568 ;02F7
.dw 0x0000 ;02F8
.dw 0x0006 ;02F9
.dw 0x0006 ;02FA
.dw 0x054F ;02FB
.dw 0x001A ;02FC
.dw 0x0060 ;02FD
.dw 0x0004 ;02FE
.dw 0x0568 ;02FF
.dw 0x001E ;0300
.dw 0x001A ;0301
.dw 0x0004 ;0302
.dw 0x0547 ;0303
.dw 0x000E ;0304
.dw 0x0045 ;0305
.dw 0x05FE ;0306
.dw 0x011F ;0307
.dw 0x0001 ;0308
.dw 0x8547 ;0309
.dw 0x0012 ;030A
.dw 0xE11F ;030B
.dw 0x0547 ;030C
.dw 0x0014 ;030D
.dw 0x0000 ;030E
.dw 0x054F ;030F
.dw 0x0006 ;0310
.dw 0x0064 ;0311
.dw 0x0006 ;0312
.dw 0x0547 ;0313
.dw 0x000C ;0314
.dw 0x0008 ;0315
.dw 0x0547 ;0316
.dw 0x0018 ;0317
.dw 0x0000 ;0318
.dw 0x0616 ;0319
.dw 0x0119 ;031A
.dw 0x061B ;031B
.dw 0x011B ;031C
.dw 0x0014 ;031D
.dw 0x0624 ;031E
.dw 0x011E ;031F
.dw 0x012A ;0320
.dw 0x061F ;0321
.dw 0x011D ;0322
.dw 0x000E ;0323
.dw 0x0647 ;0324
.dw 0x05D1 ;0325
.dw 0x0119 ;0326
.dw 0xFFFF ;0327
.dw 0x8547 ;0328
.dw 0x0018 ;0329
.dw 0xC119 ;032A
.dw 0x075D ;032B
.dw 0x0547 ;032C
.dw 0x0016 ;032D
.dw 0x1101 ;032E
.dw 0x0547 ;032F
.dw 0x0028 ;0330
.dw 0x0000 ;0331
.dw 0x076B ;0332
.dw 0x02C2 ;0333
.dw 0x8547 ;0334
.dw 0x0028 ;0335
.dw 0xC119 ;0336
.dw 0x075D ;0337
.dw 0x04F9 ;0338
.dw 0x00B0 ;0339
.dw 0x002E ;033A
.dw 0x0002 ;033B
.dw 0x0611 ;033C
.dw 0x00B0 ;033D
.dw 0x0200 ;033E
.dw 0x053B ;033F
.dw 0x034D ;0340
.dw 0x05EB ;0341
.dw 0x00B1 ;0342
.dw 0x0018 ;0343
.dw 0x053F ;0344
.dw 0x03C4 ;0345
.dw 0x0611 ;0346
.dw 0x00B0 ;0347
.dw 0x0100 ;0348
.dw 0x053B ;0349
.dw 0x0397 ;034A
.dw 0x0000 ;034B
.dw 0x9508 ;034C
.dw 0x8568 ;034D
.dw 0x0000 ;034E
.dw 0x0000 ;034F
.dw 0xC109 ;0350
.dw 0x04F9 ;0351
.dw 0x00B0 ;0352
.dw 0x0026 ;0353
.dw 0x0004 ;0354
.dw 0x0616 ;0355
.dw 0x00B4 ;0356
.dw 0x061B ;0357
.dw 0x00B6 ;0358
.dw 0x0100 ;0359
.dw 0x0518 ;035A
.dw 0x00B0 ;035B
.dw 0x00B4 ;035C
.dw 0x0004 ;035D
.dw 0x054F ;035E
.dw 0x002A ;035F
.dw 0x00B0 ;0360
.dw 0x0004 ;0361
.dw 0x0547 ;0362
.dw 0x0026 ;0363
.dw 0x3412 ;0364
.dw 0x0547 ;0365
.dw 0x0028 ;0366
.dw 0x0000 ;0367
.dw 0x0568 ;0368
.dw 0x0024 ;0369
.dw 0x0022 ;036A
.dw 0x0002 ;036B
.dw 0x0568 ;036C
.dw 0x0022 ;036D
.dw 0x0024 ;036E
.dw 0x0002 ;036F
.dw 0x04F9 ;0370
.dw 0x00B0 ;0371
.dw 0x002E ;0372
.dw 0x0002 ;0373
.dw 0x0603 ;0374
.dw 0x00B0 ;0375
.dw 0xEFFF ;0376
.dw 0x05FE ;0377
.dw 0x00B0 ;0378
.dw 0x1000 ;0379
.dw 0x8547 ;037A
.dw 0x002E ;037B
.dw 0xC0B0 ;037C
.dw 0x0547 ;037D
.dw 0x0030 ;037E
.dw 0x0020 ;037F
.dw 0x076B ;0380
.dw 0x0386 ;0381
.dw 0x85BF ;0382
.dw 0xC109 ;0383
.dw 0x0000 ;0384
.dw 0x9508 ;0385
.dw 0x0547 ;0386
.dw 0x0016 ;0387
.dw 0x0640 ;0388
.dw 0x076B ;0389
.dw 0x02F7 ;038A
.dw 0x0547 ;038B
.dw 0x0032 ;038C
.dw 0x0000 ;038D
.dw 0x0547 ;038E
.dw 0x0034 ;038F
.dw 0x0000 ;0390
.dw 0x076B ;0391
.dw 0x02C2 ;0392
.dw 0x8547 ;0393
.dw 0x0032 ;0394
.dw 0xC119 ;0395
.dw 0x075D ;0396
.dw 0x0568 ;0397
.dw 0x0026 ;0398
.dw 0x002A ;0399
.dw 0x0004 ;039A
.dw 0x061B ;039B
.dw 0x00B4 ;039C
.dw 0x0000 ;039D
.dw 0x061B ;039E
.dw 0x00B6 ;039F
.dw 0x0100 ;03A0
.dw 0x04F9 ;03A1
.dw 0x00B0 ;03A2
.dw 0x0026 ;03A3
.dw 0x0004 ;03A4
.dw 0x0518 ;03A5
.dw 0x00B0 ;03A6
.dw 0x00B4 ;03A7
.dw 0x0004 ;03A8
.dw 0x054F ;03A9
.dw 0x002A ;03AA
.dw 0x00B0 ;03AB
.dw 0x0004 ;03AC
.dw 0x0547 ;03AD
.dw 0x002E ;03AE
.dw 0x1150 ;03AF
.dw 0x0547 ;03B0
.dw 0x0030 ;03B1
.dw 0x0020 ;03B2
.dw 0x0568 ;03B3
.dw 0x0024 ;03B4
.dw 0x0022 ;03B5
.dw 0x0002 ;03B6
.dw 0x0568 ;03B7
.dw 0x0022 ;03B8
.dw 0x0024 ;03B9
.dw 0x0002 ;03BA
.dw 0x0547 ;03BB
.dw 0x0010 ;03BC
.dw 0x2800 ;03BD
.dw 0x076B ;03BE
.dw 0x0386 ;03BF
.dw 0x05BF ;03C0
.dw 0x0036 ;03C1
.dw 0x0000 ;03C2
.dw 0x9508 ;03C3
.dw 0x0603 ;03C4
.dw 0x00B0 ;03C5
.dw 0x00F0 ;03C6
.dw 0x049E ;03C7
.dw 0x00B0 ;03C8
.dw 0xFFFE ;03C9
.dw 0x861B ;03CA
.dw 0x00B2 ;03CB
.dw 0xC0B0 ;03CC
.dw 0x05FE ;03CD
.dw 0x00B0 ;03CE
.dw 0x0022 ;03CF
.dw 0x861B ;03D0
.dw 0x0124 ;03D1
.dw 0xC0B0 ;03D2
.dw 0x04F9 ;03D3
.dw 0x0126 ;03D4
.dw 0x0010 ;03D5
.dw 0x0002 ;03D6
.dw 0x861B ;03D7
.dw 0x0126 ;03D8
.dw 0xE126 ;03D9
.dw 0x85F9 ;03DA
.dw 0x0126 ;03DB
.dw 0xC0B2 ;03DC
.dw 0x05F9 ;03DD
.dw 0x0126 ;03DE
.dw 0x0014 ;03DF
.dw 0x061F ;03E0
.dw 0x00AD ;03E1
.dw 0x0001 ;03E2
.dw 0x061F ;03E3
.dw 0x0121 ;03E4
.dw 0x0000 ;03E5
.dw 0x0547 ;03E6
.dw 0x0030 ;03E7
.dw 0x0020 ;03E8
.dw 0x0568 ;03E9
.dw 0x0024 ;03EA
.dw 0x0022 ;03EB
.dw 0x0002 ;03EC
.dw 0x0568 ;03ED
.dw 0x0022 ;03EE
.dw 0x0024 ;03EF
.dw 0x0002 ;03F0
.dw 0x0547 ;03F1
.dw 0x002E ;03F2
.dw 0x1050 ;03F3
.dw 0x076B ;03F4
.dw 0x0419 ;03F5
.dw 0x04F9 ;03F6
.dw 0x0138 ;03F7
.dw 0x002A ;03F8
.dw 0x0004 ;03F9
.dw 0x0000 ;03FA
rcall import_tcp_recv
.dw 0xD381 ;03FC
.dw 0x061F ;03FD
.dw 0x00AD ;03FE
.dw 0x0000 ;03FF
.dw 0x06B9 ;0400
.dw 0x0547 ;0401
.dw 0x002E ;0402
.dw 0x1950 ;0403
.dw 0x0616 ;0404
.dw 0x00BA ;0405
.dw 0x861B ;0406
.dw 0x00BC ;0407
.dw 0xE126 ;0408
.dw 0x04F9 ;0409
.dw 0x00B0 ;040A
.dw 0x0026 ;040B
.dw 0x0004 ;040C
.dw 0x0518 ;040D
.dw 0x00B0 ;040E
.dw 0x00BA ;040F
.dw 0x0004 ;0410
.dw 0x054F ;0411
.dw 0x002A ;0412
.dw 0x00B0 ;0413
.dw 0x0004 ;0414
.dw 0x076B ;0415
.dw 0x0427 ;0416
.dw 0x0000 ;0417
.dw 0x9508 ;0418
.dw 0x061F ;0419
.dw 0x0137 ;041A
.dw 0x002B ;041B
.dw 0x0624 ;041C
.dw 0x0123 ;041D
.dw 0x012A ;041E
.dw 0x061F ;041F
.dw 0x0122 ;0420
.dw 0x0036 ;0421
.dw 0x075D ;0422
.dw 0x076B ;0423
.dw 0x0427 ;0424
.dw 0x07FE ;0425
.dw 0x0419 ;0426
.dw 0x054F ;0427
.dw 0x0026 ;0428
.dw 0x0138 ;0429
.dw 0x0004 ;042A
.dw 0x861B ;042B
.dw 0x00B0 ;042C
.dw 0xC122 ;042D
.dw 0x0624 ;042E
.dw 0x00BB ;042F
.dw 0x012A ;0430
.dw 0x061F ;0431
.dw 0x00BA ;0432
.dw 0x0036 ;0433
.dw 0x85F9 ;0434
.dw 0x00B0 ;0435
.dw 0xC0BA ;0436
.dw 0x861B ;0437
.dw 0x00B4 ;0438
.dw 0xE0B0 ;0439
.dw 0x05FE ;043A
.dw 0x00B0 ;043B
.dw 0x0028 ;043C
.dw 0x8547 ;043D
.dw 0x0010 ;043E
.dw 0xE0B0 ;043F
.dw 0x861B ;0440
.dw 0x00B8 ;0441
.dw 0xC0B0 ;0442
.dw 0x05FE ;0443
.dw 0x00B8 ;0444
.dw 0x000E ;0445
.dw 0x0616 ;0446
.dw 0x00B2 ;0447
.dw 0x0518 ;0448
.dw 0x0138 ;0449
.dw 0x00B2 ;044A
.dw 0x0004 ;044B
.dw 0x076B ;044C
.dw 0x0386 ;044D
.dw 0x85BF ;044E
.dw 0xC0B8 ;044F
.dw 0x075D ;0450
.dw 0x0001 ;0451
.dw 0xE0AA ;0452
.dw 0xE0B0 ;0453
.dw 0xE002 ;0454
.dw 0x2EC0 ;0455
.dw 0xC003 ;0456
.dw 0x0002 ;0457
.dw 0x2DAA ;0458
.dw 0x2DBB ;0459
.dw 0x91EF ;045A
.dw 0x91FF ;045B
.dw 0x24DD ;045C
.dw 0x0DAC ;045D
.dw 0x1DBD ;045E
.dw 0x90DE ;045F
.dw 0x92DF ;0460
.dw 0x94CA ;0461
.dw 0xF7E1 ;0462
.dw 0x93FF ;0463
.dw 0x93EF ;0464
.dw 0x9508 ;0465
.dw 0x0001 ;0466
.dw 0xE002 ;0467
.dw 0x2EC0 ;0468
.dw 0xC001 ;0469
.dw 0x0002 ;046A
.dw 0x91EF ;046B
.dw 0x91FF ;046C
.dw 0x2DAA ;046D
.dw 0x2DBB ;046E
.dw 0x90AF ;046F
.dw 0x92AD ;0470
.dw 0x94CA ;0471
.dw 0xF7E1 ;0472
.dw 0x93FF ;0473
.dw 0x93EF ;0474
.dw 0x9508 ;0475
.dw 0x0001 ;0476
.dw 0xC007 ;0477
.dw 0x8002 ;0478
.dw 0xD004 ;0479
.dw 0x2DCC ;047A
.dw 0x2DDD ;047B
.dw 0xD26A ;047C
.dw 0x9508 ;047D
.dw 0xD28F ;047E
.dw 0x93FF ;047F
.dw 0x93EF ;0480
.dw 0x2DEA ;0481
.dw 0x2DFB ;0482
.dw 0xE890 ;0483
.dw 0x239F ;0484
.dw 0xF479 ;0485
.dw 0x0FEE ;0486
.dw 0x1FFF ;0487
.dw 0x2E0E ;0488
.dw 0x2A0F ;0489
.dw 0xF039 ;048A
.dw 0x95C8 ;048B
.dw 0x9631 ;048C
.dw 0x2000 ;048D
.dw 0xF019 ;048E
.dw 0x2D90 ;048F
.dw 0xD2B8 ;0490
.dw 0xCFF9 ;0491
.dw 0x91EF ;0492
.dw 0x91FF ;0493
.dw 0x9508 ;0494
.dw 0x77FF ;0495
.dw 0x2FCE ;0496
.dw 0x2FDF ;0497
rcall import_seeprom_read          ; read next byte
.dw 0x2D92 ;0499
.dw 0x2399 ;049A
.dw 0xF3B1 ;049B
.dw 0xD2AC ;049C
.dw 0xCFFA ;049D
.dw 0x0002 ;049E
.dw 0xD141 ;049F
.dw 0x9100 ;04A0
.dw 0x013C ;04A1
.dw 0x6800 ;04A2
.dw 0x20CC ;04A3
.dw 0xF091 ;04A4
.dw 0xF03C ;04A5
.dw 0xBF0F ;04A6
.dw 0x0C00 ;04A7
.dw 0x1C11 ;04A8
.dw 0xB70F ;04A9
.dw 0x94CA ;04AA
.dw 0xF7D1 ;04AB
.dw 0xC007 ;04AC
.dw 0x94C1 ;04AD
.dw 0xBF0F ;04AE
.dw 0x9416 ;04AF
.dw 0x9407 ;04B0
.dw 0xB70F ;04B1
.dw 0x94CA ;04B2
.dw 0xF7D1 ;04B3
.dw 0xBF0F ;04B4
.dw 0x2011 ;04B5
.dw 0xC11F ;04B6
.dw 0x9508 ;04B7
.dw 0x8003 ;04B8
.dw 0xDFC4 ;04B9
.dw 0x2DAC ;04BA
.dw 0x2DBD ;04BB
.dw 0x902D ;04BC
.dw 0xD232 ;04BD
.dw 0xE091 ;04BE
.dw 0x1AE9 ;04BF
.dw 0xE090 ;04C0
.dw 0x0AF9 ;04C1
.dw 0xF7C9 ;04C2
.dw 0x9508 ;04C3
.dw 0x8003 ;04C4
.dw 0x9150 ;04C5
.dw 0x0105 ;04C6
.dw 0xE044 ;04C7
.dw 0xECEB ;04C8
.dw 0xE0F4 ;04C9
.dw 0xC010 ;04CA
.dw 0x2D92 ;04CB
.dw 0xD27C ;04CC
.dw 0x2D93 ;04CD
.dw 0xD27A ;04CE
.dw 0x9508 ;04CF
.dw 0x8003 ;04D0
.dw 0x9150 ;04D1
.dw 0x012A ;04D2
.dw 0x2744 ;04D3
.dw 0xC004 ;04D4
.dw 0x8003 ;04D5
.dw 0x9150 ;04D6
.dw 0x0105 ;04D7
.dw 0xE044 ;04D8
.dw 0xEEE8 ;04D9
.dw 0xE0F4 ;04DA
.dw 0xDFA2 ;04DB
.dw 0xE39D ;04DC
.dw 0xD26B ;04DD
.dw 0x0D4C ;04DE
.dw 0x1D5D ;04DF
.dw 0x2D2E ;04E0
.dw 0x2D3F ;04E1
.dw 0xE091 ;04E2
.dw 0x2392 ;04E3
.dw 0xF011 ;04E4
.dw 0x5F2F ;04E5
.dw 0x4F3F ;04E6
.dw 0xCB7B ;04E7
.dw 0xD207 ;04E8
.dw 0xE091 ;04E9
.dw 0x1AE9 ;04EA
.dw 0xE090 ;04EB
.dw 0x0AF9 ;04EC
.dw 0xF031 ;04ED
.dw 0x2C23 ;04EE
.dw 0xD200 ;04EF
.dw 0xE091 ;04F0
.dw 0x1AE9 ;04F1
.dw 0xE090 ;04F2
.dw 0x0AF9 ;04F3
.dw 0x9508 ;04F4
.dw 0x0003 ;04F5
.dw 0x9150 ;04F6
.dw 0x012A ;04F7
.dw 0xC007 ;04F8
.dw 0x0003 ;04F9
.dw 0xE094 ;04FA
.dw 0x0EC9 ;04FB
.dw 0xE090 ;04FC
.dw 0x1ED9 ;04FD
.dw 0x9150 ;04FE
.dw 0x0105 ;04FF
.dw 0x2DAA ;0500
.dw 0x2DBB ;0501
.dw 0x2744 ;0502
.dw 0x0D4C ;0503
.dw 0x1D5D ;0504
.dw 0x2D2E ;0505
.dw 0x2D3F ;0506
.dw 0xE7E3 ;0507
.dw 0xE0F1 ;0508
.dw 0xCB59 ;0509
.dw 0x0003 ;050A
.dw 0x2DAA ;050B
.dw 0x2DBB ;050C
.dw 0x2DCC ;050D
.dw 0x2DDD ;050E
.dw 0x2DEE ;050F
.dw 0x2DFF ;0510
.dw 0x900D ;0511
.dw 0x9019 ;0512
.dw 0x1401 ;0513
.dw 0xF411 ;0514
.dw 0x9731 ;0515
.dw 0xF7D1 ;0516
.dw 0xC0C5 ;0517
.dw 0x0003 ;0518
.dw 0xE1EC ;0519
.dw 0xE0F5 ;051A
.dw 0xC008 ;051B
.dw 0x1C01 ;051C
.dw 0x9508 ;051D
.dw 0x0003 ;051E
.dw 0xE2E2 ;051F
.dw 0xE0F5 ;0520
.dw 0xC002 ;0521
.dw 0x0801 ;0522
.dw 0x9508 ;0523
.dw 0x2DAA ;0524
.dw 0x2DBB ;0525
.dw 0x2DCC ;0526
.dw 0x2DDD ;0527
.dw 0x24FF ;0528
.dw 0x0DAE ;0529
.dw 0x1DBF ;052A
.dw 0x0DCE ;052B
.dw 0x1DDF ;052C
.dw 0x9488 ;052D
.dw 0x900E ;052E
.dw 0x901A ;052F
.dw 0x9509 ;0530
.dw 0x920C ;0531
.dw 0x94EA ;0532
.dw 0xF7D1 ;0533
.dw 0x9508 ;0534
.dw 0xD0AB ;0535
.dw 0x9100 ;0536
.dw 0x013C ;0537
.dw 0x6800 ;0538
.dw 0xBF0F ;0539
.dw 0x9508 ;053A
.dw 0x0001 ;053B
.dw 0xDFF9 ;053C
.dw 0xF421 ;053D
.dw 0x9508 ;053E
.dw 0x0001 ;053F
.dw 0xDFF5 ;0540
.dw 0xF7E1 ;0541
.dw 0xC2BC ;0542
.dw 0x0001 ;0543
.dw 0xDFF1 ;0544
.dw 0xF3E0 ;0545
.dw 0x9508 ;0546
.dw 0x0002 ;0547
.dw 0x2C8C ;0548
.dw 0x2C9D ;0549
.dw 0xE0A8 ;054A
.dw 0xE0B0 ;054B
.dw 0xE022 ;054C
.dw 0xE030 ;054D
.dw 0xC005 ;054E
.dw 0x0003 ;054F
.dw 0x2DAC ;0550
.dw 0x2DBD ;0551
.dw 0x2D2E ;0552
.dw 0x2D3F ;0553
.dw 0xE5EC ;0554
.dw 0xE0F5 ;0555
.dw 0x9150 ;0556
.dw 0x012A ;0557
.dw 0x2744 ;0558
.dw 0x0D4A ;0559
.dw 0x1D5B ;055A
.dw 0xCB2E ;055B
.dw 0x902D ;055C
.dw 0x903D ;055D
.dw 0x9508 ;055E
.dw 0x0002 ;055F
.dw 0x2D2C ;0560
.dw 0x2D3D ;0561
.dw 0xE6E5 ;0562
.dw 0xE0F5 ;0563
.dw 0xCFF1 ;0564
.dw 0x2422 ;0565
.dw 0x2433 ;0566
.dw 0x9508 ;0567
.dw 0x0003 ;0568
.dw 0xE094 ;0569
.dw 0x0EC9 ;056A
.dw 0xE090 ;056B
.dw 0x1ED9 ;056C
.dw 0x9150 ;056D
.dw 0x0105 ;056E
.dw 0x2744 ;056F
.dw 0x0D4C ;0570
.dw 0x1D5D ;0571
.dw 0x2D0E ;0572
.dw 0x2D1F ;0573
.dw 0x3200 ;0574
.dw 0xE090 ;0575
.dw 0x0719 ;0576
.dw 0xF10A ;0577
.dw 0xE220 ;0578
.dw 0xE030 ;0579
.dw 0xEEC0 ;057A
.dw 0xE0D0 ;057B
.dw 0xEBE9 ;057C
.dw 0xE0F5 ;057D
.dw 0xDAE4 ;057E
.dw 0x9150 ;057F
.dw 0x012A ;0580
.dw 0x2744 ;0581
.dw 0x0D4A ;0582
.dw 0x1D5B ;0583
.dw 0xE220 ;0584
.dw 0xE030 ;0585
.dw 0xEEC0 ;0586
.dw 0xE0D0 ;0587
.dw 0xEBEC ;0588
.dw 0xE0F5 ;0589
.dw 0xDAFF ;058A
.dw 0xE290 ;058B
.dw 0x0EA9 ;058C
.dw 0xE090 ;058D
.dw 0x1EB9 ;058E
.dw 0xE290 ;058F
.dw 0x0EC9 ;0590
.dw 0xE090 ;0591
.dw 0x1ED9 ;0592
.dw 0xE290 ;0593
.dw 0x1AE9 ;0594
.dw 0xE090 ;0595
.dw 0x0AF9 ;0596
.dw 0xF6A9 ;0597
.dw 0x9508 ;0598
.dw 0x2D2E ;0599
.dw 0x2D3F ;059A
.dw 0xEEC0 ;059B
.dw 0xE0D0 ;059C
.dw 0xEBE9 ;059D
.dw 0xE0F5 ;059E
.dw 0xDAC3 ;059F
.dw 0x9150 ;05A0
.dw 0x012A ;05A1
.dw 0x2744 ;05A2
.dw 0x0D4A ;05A3
.dw 0x1D5B ;05A4
.dw 0x2D2E ;05A5
.dw 0x2D3F ;05A6
.dw 0xEEC0 ;05A7
.dw 0xE0D0 ;05A8
.dw 0xEBEC ;05A9
.dw 0xE0F5 ;05AA
.dw 0xDADE ;05AB
.dw 0xE290 ;05AC
.dw 0x0EA9 ;05AD
.dw 0xE090 ;05AE
.dw 0x1EB9 ;05AF
.dw 0xE290 ;05B0
.dw 0x0EC9 ;05B1
.dw 0xE090 ;05B2
.dw 0x1ED9 ;05B3
.dw 0xE290 ;05B4
.dw 0x1AE9 ;05B5
.dw 0xE090 ;05B6
.dw 0x0AF9 ;05B7
.dw 0x9508 ;05B8
.dw 0x9229 ;05B9
.dw 0x9239 ;05BA
.dw 0x9508 ;05BB
.dw 0x9029 ;05BC
.dw 0x9039 ;05BD
.dw 0x9508 ;05BE
.dw 0x0001 ;05BF
.dw 0x9150 ;05C0
.dw 0x012A ;05C1
.dw 0x2744 ;05C2
.dw 0x2D2A ;05C3
.dw 0x2D3B ;05C4
.dw 0xCAF9 ;05C5
.dw 0x0002 ;05C6
.dw 0xDF6D ;05C7
.dw 0x280C ;05C8
.dw 0x281D ;05C9
.dw 0xC00B ;05CA
.dw 0x0001 ;05CB
.dw 0x24CC ;05CC
.dw 0x24DD ;05CD
.dw 0x94CA ;05CE
.dw 0x94DA ;05CF
.dw 0xC001 ;05D0
.dw 0x0002 ;05D1
.dw 0xDF62 ;05D2
.dw 0x240C ;05D3
.dw 0x241D ;05D4
.dw 0xC000 ;05D5
.dw 0x921E ;05D6
.dw 0x920E ;05D7
.dw 0xB70F ;05D8
.dw 0x2000 ;05D9
.dw 0xF019 ;05DA
.dw 0x7F0D ;05DB
.dw 0xC001 ;05DC
.dw 0xB70F ;05DD
.dw 0x9300 ;05DE
.dw 0x013C ;05DF
.dw 0x9508 ;05E0
.dw 0x2DAA ;05E1
.dw 0x2DBB ;05E2
.dw 0x900D ;05E3
.dw 0x901D ;05E4
.dw 0x9508 ;05E5
.dw 0x0002 ;05E6
.dw 0xDFF9 ;05E7
.dw 0x140C ;05E8
.dw 0x041D ;05E9
.dw 0xCFF2 ;05EA
.dw 0x0002 ;05EB
.dw 0xDFF4 ;05EC
.dw 0x140C ;05ED
.dw 0xCFEE ;05EE
.dw 0x0001 ;05EF
.dw 0x24CC ;05F0
.dw 0x24DD ;05F1
.dw 0x94C3 ;05F2
.dw 0xC00B ;05F3
.dw 0x0001 ;05F4
.dw 0x24CC ;05F5
.dw 0x24DD ;05F6
.dw 0x94C3 ;05F7
.dw 0xC001 ;05F8
.dw 0x0002 ;05F9
.dw 0xDFE6 ;05FA
.dw 0x180C ;05FB
.dw 0x081D ;05FC
.dw 0xCFD8 ;05FD
.dw 0x0002 ;05FE
.dw 0xDFE1 ;05FF
.dw 0x0C0C ;0600
.dw 0x1C1D ;0601
.dw 0xCFD3 ;0602
.dw 0x0002 ;0603
.dw 0xDF30 ;0604
.dw 0x200C ;0605
.dw 0x201D ;0606
.dw 0xCFCE ;0607
.dw 0x0001 ;0608
.dw 0xDFD7 ;0609
.dw 0x24CC ;060A
.dw 0x24DD ;060B
.dw 0x18C0 ;060C
.dw 0x08D1 ;060D
.dw 0x2C0C ;060E
.dw 0x2C1D ;060F
.dw 0xCFC5 ;0610
.dw 0x0002 ;0611
.dw 0xDF22 ;0612
.dw 0x200C ;0613
.dw 0x201D ;0614
.dw 0xCFC2 ;0615
.dw 0x0001 ;0616
.dw 0xDF1D ;0617
.dw 0x2400 ;0618
.dw 0x2411 ;0619
.dw 0xCFBB ;061A
.dw 0x0002 ;061B
.dw 0xD003 ;061C
.dw 0x92DD ;061D
.dw 0x9508 ;061E
.dw 0x0002 ;061F
.dw 0x2DAA ;0620
.dw 0x2DBB ;0621
.dw 0x92CD ;0622
.dw 0x9508 ;0623
.dw 0x0002 ;0624
.dw 0xE021 ;0625
.dw 0xE030 ;0626
.dw 0xC003 ;0627
.dw 0x0003 ;0628
.dw 0x2D2E ;0629
.dw 0x2D3F ;062A
.dw 0x2DAA ;062B
.dw 0x2DBB ;062C
.dw 0x2DCC ;062D
.dw 0x2DDD ;062E
.dw 0x9009 ;062F
.dw 0x920D ;0630
.dw 0x5021 ;0631
.dw 0x4030 ;0632
.dw 0xF7D9 ;0633
.dw 0x9508 ;0634
.dw 0x2755 ;0635
.dw 0xC01F ;0636
.dw 0x0000 ;0637
.dw 0x91A0 ;0638
.dw 0x011D ;0639
.dw 0x91B0 ;063A
.dw 0x011E ;063B
.dw 0x2755 ;063C
.dw 0xC010 ;063D
.dw 0x902D ;063E
.dw 0x903D ;063F
.dw 0x9509 ;0640
.dw 0x5021 ;0641
.dw 0x4030 ;0642
.dw 0x5021 ;0643
.dw 0x4030 ;0644
.dw 0xF7C1 ;0645
.dw 0x9508 ;0646
.dw 0x0000 ;0647
.dw 0xE6E3 ;0648
.dw 0xE0F0 ;0649
.dw 0x9140 ;064A
.dw 0x011D ;064B
.dw 0x9150 ;064C
.dw 0x011E ;064D
.dw 0x9120 ;064E
.dw 0x011B ;064F
.dw 0x9130 ;0650
.dw 0x011C ;0651
.dw 0x90A0 ;0652
.dw 0x0119 ;0653
.dw 0x90B0 ;0654
.dw 0x011A ;0655
.dw 0x24DD ;0656
.dw 0x94D0 ;0657
.dw 0xE091 ;0658
.dw 0x2392 ;0659
.dw 0xF019 ;065A
.dw 0x5F2F ;065B
.dw 0x4F3F ;065C
.dw 0x94D0 ;065D
.dw 0x2EC2 ;065E
.dw 0x2AC3 ;065F
.dw 0xF089 ;0660
.dw 0x24CC ;0661
.dw 0xE7E6 ;0662
.dw 0xE0F6 ;0663
.dw 0x2355 ;0664
.dw 0xF411 ;0665
.dw 0xDFD7 ;0666
.dw 0xC001 ;0667
.dw 0xD9FA ;0668
.dw 0x94C6 ;0669
.dw 0x1CAC ;066A
.dw 0x1CBC ;066B
.dw 0x1CAC ;066C
.dw 0x1CBC ;066D
.dw 0x92A0 ;066E
.dw 0x0119 ;066F
.dw 0x92B0 ;0670
.dw 0x011A ;0671
.dw 0x94A0 ;0672
.dw 0x94B0 ;0673
.dw 0x28AB ;0674
.dw 0xCF67 ;0675
.dw 0x3022 ;0676
.dw 0xF419 ;0677
.dw 0x3030 ;0678
.dw 0xF409 ;0679
.dw 0x203D ;067A
.dw 0x94C6 ;067B
.dw 0x1CA2 ;067C
.dw 0x1CB3 ;067D
.dw 0x1CCC ;067E
.dw 0x9508 ;067F
.dw 0x92FF ;0680
.dw 0x92EF ;0681
.dw 0x93DF ;0682
.dw 0x93CF ;0683
.dw 0x2EF9 ;0684
.dw 0x90E0 ;0685
.dw 0x0121 ;0686
.dw 0xEEC0 ;0687
.dw 0xE0D0 ;0688
.dw 0x2400 ;0689
.dw 0x0DCE ;068A
.dw 0x1DD0 ;068B
.dw 0x92F9 ;068C
.dw 0x94E3 ;068D
.dw 0x92E0 ;068E
.dw 0x0121 ;068F
.dw 0xE210 ;0690
.dw 0x16E1 ;0691
.dw 0xF10C ;0692
.dw 0xD026 ;0693
.dw 0x90E0 ;0694
.dw 0x0137 ;0695
.dw 0x94EA ;0696
.dw 0x92E0 ;0697
.dw 0x0137 ;0698
.dw 0xF4D1 ;0699
.dw 0x93BF ;069A
.dw 0x93AF ;069B
.dw 0x93FF ;069C
.dw 0x93EF ;069D
.dw 0x27AA ;069E
.dw 0x27BB ;069F
.dw 0xE1EA ;06A0
.dw 0x91FD ;06A1
.dw 0x93FF ;06A2
.dw 0x95EA ;06A3
.dw 0xF7E1 ;06A4
.dw 0xD0D8 ;06A5
.dw 0x076B ;06A6
.dw 0x0423 ;06A7
.dw 0x0000 ;06A8
.dw 0xE1EA ;06A9
.dw 0x2FAE ;06AA
.dw 0x27BB ;06AB
.dw 0x91FF ;06AC
.dw 0x93FE ;06AD
.dw 0x95EA ;06AE
.dw 0xF7E1 ;06AF
.dw 0x91EF ;06B0
.dw 0x91FF ;06B1
.dw 0x91AF ;06B2
.dw 0x91BF ;06B3
.dw 0x91CF ;06B4
.dw 0x91DF ;06B5
.dw 0x90EF ;06B6
.dw 0x90FF ;06B7
.dw 0x9508 ;06B8
.dw 0x0000 ;06B9
.dw 0x933F ;06BA
.dw 0x932F ;06BB
.dw 0x935F ;06BC
.dw 0x934F ;06BD
.dw 0x937F ;06BE
.dw 0x936F ;06BF
.dw 0x9120 ;06C0
.dw 0x0121 ;06C1
.dw 0x2322 ;06C2
.dw 0xF0E1 ;06C3
.dw 0x2733 ;06C4
.dw 0x9160 ;06C5
.dw 0x0122 ;06C6
.dw 0x9170 ;06C7
.dw 0x0123 ;06C8
.dw 0x2F46 ;06C9
.dw 0x2F57 ;06CA
.dw 0x0F62 ;06CB
.dw 0x1F73 ;06CC
.dw 0x9360 ;06CD
.dw 0x0122 ;06CE
.dw 0x9370 ;06CF
.dw 0x0123 ;06D0
.dw 0x5F2F ;06D1
.dw 0x4F3F ;06D2
.dw 0x7F2E ;06D3
.dw 0x27AA ;06D4
.dw 0x93A0 ;06D5
.dw 0x0121 ;06D6
.dw 0xEEA0 ;06D7
.dw 0xE0B0 ;06D8
.dw 0x93FF ;06D9
.dw 0x93EF ;06DA
.dw 0xE5EC ;06DB
.dw 0xE0F5 ;06DC
.dw 0xD9AC ;06DD
.dw 0x91EF ;06DE
.dw 0x91FF ;06DF
.dw 0x916F ;06E0
.dw 0x917F ;06E1
.dw 0x914F ;06E2
.dw 0x915F ;06E3
.dw 0x912F ;06E4
.dw 0x913F ;06E5
.dw 0x9508 ;06E6
.dw 0x922F ;06E7
.dw 0x2E2D ;06E8
.dw 0xD006 ;06E9
.dw 0x2E2C ;06EA
.dw 0xD004 ;06EB
.dw 0x902F ;06EC
.dw 0x9508 ;06ED
.dw 0x0001 ;06EE
.dw 0x2D9A ;06EF
.dw 0x939F ;06F0
.dw 0x930F ;06F1
.dw 0x2D02 ;06F2
.dw 0x9506 ;06F3
.dw 0x9506 ;06F4
.dw 0x9506 ;06F5
.dw 0x9506 ;06F6
.dw 0xD005 ;06F7
.dw 0x2D02 ;06F8
.dw 0xD003 ;06F9
.dw 0x910F ;06FA
.dw 0x919F ;06FB
.dw 0x9508 ;06FC
.dw 0x700F ;06FD
.dw 0x5D00 ;06FE
.dw 0x330A ;06FF
.dw 0xF00C ;0700
.dw 0x5F09 ;0701
.dw 0x2F90 ;0702
.dw 0xD045 ;0703
.dw 0x9508 ;0704
.dw 0x0000 ;0705
.dw 0x939F ;0706
.dw 0xE09D ;0707
.dw 0xD040 ;0708
.dw 0xE09A ;0709
.dw 0xD03E ;070A
.dw 0x919F ;070B
.dw 0x9508 ;070C
.dw 0x0000 ;070D
.dw 0x939F ;070E
.dw 0xE290 ;070F
.dw 0xD038 ;0710
.dw 0x919F ;0711
.dw 0x9508 ;0712
.dw 0x0001 ;0713
.dw 0x2DAA ;0714
.dw 0x2DBB ;0715
.dw 0x919D ;0716
.dw 0xC031 ;0717
.dw 0x0001 ;0718
.dw 0x2D9A ;0719
.dw 0xC02E ;071A
.dw 0x0003 ;071B
.dw 0x2DEC ;071C
.dw 0x2DFD ;071D
.dw 0x2D2E ;071E
.dw 0x2D3F ;071F
.dw 0x9150 ;0720
.dw 0x012A ;0721
.dw 0x2744 ;0722
.dw 0x0D4A ;0723
.dw 0x1D5B ;0724
.dw 0xD964 ;0725
.dw 0x93A0 ;0726
.dw 0x0119 ;0727
.dw 0x93B0 ;0728
.dw 0x011A ;0729
.dw 0x9508 ;072A
.dw 0x91FF ;072B
.dw 0x91EF ;072C
.dw 0x0FEE ;072D
.dw 0x1FFF ;072E
.dw 0x95C8 ;072F
.dw 0x60E1 ;0730
.dw 0x2C10 ;0731
.dw 0x95C8 ;0732
.dw 0x9631 ;0733
.dw 0x95F6 ;0734
.dw 0x95E7 ;0735
.dw 0x93EF ;0736
.dw 0x93FF ;0737
.dw 0x2DE1 ;0738
.dw 0x2DF0 ;0739
.dw 0x95C8 ;073A
.dw 0x9631 ;073B
.dw 0x2000 ;073C
.dw 0xF019 ;073D
.dw 0x2D90 ;073E
.dw 0xD009 ;073F
.dw 0xCFF9 ;0740
.dw 0x9508 ;0741
.dw 0x9029 ;0742
.dw 0x2022 ;0743
.dw 0xF019 ;0744
.dw 0x2D92 ;0745
.dw 0xD002 ;0746
.dw 0xCFFA ;0747
.dw 0x9508 ;0748
.dw 0x931F ;0749
.dw 0x9110 ;074A
.dw 0x00AD ;074B
.dw 0x2311 ;074C
.dw 0xF419 ;074D
rcall import_serial_putchar
.dw 0x911F ;074F
.dw 0x9508 ;0750
.dw 0xDF2E ;0751
.dw 0xCFFC ;0752
.dw 0xE20D ;0753
.dw 0xE011 ;0754
.dw 0x9300 ;0755
.dw 0x012B ;0756
.dw 0x9310 ;0757
.dw 0x012C ;0758
.dw 0x2400 ;0759
.dw 0x9200 ;075A
.dw 0x0100 ;075B
.dw 0x9508 ;075C
.dw 0x0000 ;075D
.dw 0x91EF ;075E
.dw 0x91FF ;075F
.dw 0x91C0 ;0760
.dw 0x012B ;0761
.dw 0x91D0 ;0762
.dw 0x012C ;0763
.dw 0x905A ;0764
.dw 0x904A ;0765
.dw 0x93C0 ;0766
.dw 0x012B ;0767
.dw 0x93D0 ;0768
.dw 0x012C ;0769
.dw 0xC017 ;076A
.dw 0x0001 ;076B
.dw 0x91EF ;076C
.dw 0x91FF ;076D
.dw 0x91C0 ;076E
.dw 0x012B ;076F
.dw 0x91D0 ;0770
.dw 0x012C ;0771
.dw 0x9249 ;0772
.dw 0x9259 ;0773
.dw 0x93C0 ;0774
.dw 0x012B ;0775
.dw 0x93D0 ;0776
.dw 0x012C ;0777
.dw 0x2C4A ;0778
.dw 0x2C5B ;0779
.dw 0xE890 ;077A
.dw 0x2195 ;077B
.dw 0xF429 ;077C
.dw 0xC002 ;077D
.dw 0x905F ;077E
.dw 0x904F ;077F
.dw 0x0C44 ;0780
.dw 0x1C55 ;0781
.dw 0x2DE4 ;0782
.dw 0x2DF5 ;0783
.dw 0xE890 ;0784
.dw 0x239F ;0785
.dw 0xF059 ;0786
.dw 0x2FCE ;0787
.dw 0x2FDF ;0788
.dw 0xE0AA ;0789
.dw 0xE0B0 ;078A
.dw 0xE022 ;078B
rcall import_seeprom_read_bytes
.dw 0x2C0B ;078D
.dw 0x2C1A ;078E
.dw 0x2FEC ;078F
.dw 0x2FFD ;0790
.dw 0xC005 ;0791
.dw 0x95C8 ;0792
.dw 0x2C10 ;0793
.dw 0x60E1 ;0794
.dw 0x95C8 ;0795
.dw 0x9631 ;0796
.dw 0x2E4E ;0797
.dw 0x2E5F ;0798
.dw 0x2D91 ;0799
.dw 0x2990 ;079A
.dw 0xF409 ;079B
.dw 0xC05C ;079C
.dw 0x2DF0 ;079D
.dw 0x2DE1 ;079E
.dw 0x2C70 ;079F
.dw 0x77FF ;07A0
.dw 0x0FEE ;07A1
.dw 0x1FFF ;07A2
.dw 0x95C8 ;07A3
.dw 0x2C10 ;07A4
.dw 0x60E1 ;07A5
.dw 0x95C8 ;07A6
.dw 0x2D00 ;07A7
.dw 0x95F6 ;07A8
.dw 0x95E7 ;07A9
.dw 0x2DC1 ;07AA
.dw 0x70C3 ;07AB
.dw 0x2E1C ;07AC
.dw 0x9631 ;07AD
.dw 0x2E8E ;07AE
.dw 0x2E9F ;07AF
.dw 0xE0AA ;07B0
.dw 0xE0B0 ;07B1
.dw 0x2DE4 ;07B2
.dw 0x2DF5 ;07B3
.dw 0x2011 ;07B4
.dw 0xF0F9 ;07B5
.dw 0x921F ;07B6
.dw 0xE890 ;07B7
.dw 0x239F ;07B8
.dw 0xF041 ;07B9
.dw 0x2D21 ;07BA
.dw 0x0F22 ;07BB
.dw 0x2FCE ;07BC
.dw 0x2FDF ;07BD
rcall import_seeprom_read_bytes    ; get the data
.dw 0x2FEC ;07BF
.dw 0x2FFD ;07C0
.dw 0xC008 ;07C1
.dw 0x95C8 ;07C2
.dw 0x920D ;07C3
.dw 0x60E1 ;07C4
.dw 0x95C8 ;07C5
.dw 0x920D ;07C6
.dw 0x9631 ;07C7
.dw 0x941A ;07C8
.dw 0xF7C1 ;07C9
.dw 0x2E4E ;07CA
.dw 0x2E5F ;07CB
.dw 0x901F ;07CC
.dw 0xE890 ;07CD
.dw 0x2197 ;07CE
.dw 0xF121 ;07CF
.dw 0xE0AA ;07D0
.dw 0xE0B0 ;07D1
.dw 0x2FEA ;07D2
.dw 0x2FFB ;07D3
.dw 0xC001 ;07D4
.dw 0xC01E ;07D5
.dw 0x902D ;07D6
.dw 0x903D ;07D7
.dw 0x1F00 ;07D8
.dw 0xF0C0 ;07D9
.dw 0xE890 ;07DA
.dw 0x2193 ;07DB
.dw 0xF0A9 ;07DC
.dw 0x2DC2 ;07DD
.dw 0x2DD3 ;07DE
.dw 0x2C03 ;07DF
.dw 0x71DF ;07E0
.dw 0x9029 ;07E1
.dw 0x2433 ;07E2
.dw 0xE490 ;07E3
.dw 0x2190 ;07E4
.dw 0xF009 ;07E5
.dw 0x9039 ;07E6
.dw 0xE290 ;07E7
.dw 0x2190 ;07E8
.dw 0xF019 ;07E9
.dw 0x2C02 ;07EA
.dw 0x2C23 ;07EB
.dw 0x2C30 ;07EC
.dw 0x9221 ;07ED
.dw 0x9231 ;07EE
.dw 0x941A ;07EF
.dw 0xF729 ;07F0
.dw 0xC002 ;07F1
.dw 0x9632 ;07F2
.dw 0xCFFB ;07F3
.dw 0x2DE8 ;07F4
.dw 0x2DF9 ;07F5
.dw 0x77FF ;07F6
.dw 0x9509 ;07F7
.dw 0xCF89 ;07F8
.dw 0x95F6 ;07F9
.dw 0x95E7 ;07FA
.dw 0x93EF ;07FB
.dw 0x93FF ;07FC
.dw 0x9508 ;07FD
.dw 0x0001 ;07FE
.dw 0x91EF ;07FF
.dw 0x91FF ;0800
.dw 0xCF76 ;0801
.dw 0x0002 ;0802
.dw 0x2DCA ;0803
.dw 0x2DDB ;0804
.dw 0x2C2C ;0805
.dw 0xD00F ;0806
.dw 0xBA2D ;0807
.dw 0x9AE2 ;0808
.dw 0x9AE1 ;0809
.dw 0x9508 ;080A
.dw 0x0003 ;080B
.dw 0x2DCA ;080C
.dw 0x2DDB ;080D
.dw 0x2DAC ;080E
.dw 0x2DBD ;080F
.dw 0x2D2E ;0810
.dw 0x902D ;0811
.dw 0xDFF3 ;0812
.dw 0x952A ;0813
.dw 0xF7E1 ;0814
.dw 0x9508 ;0815
.dw 0x931F ;0816
.dw 0xB31C ;0817
.dw 0xFB11 ;0818
.dw 0xF3EE ;0819
.dw 0x911F ;081A
.dw 0xBBCE ;081B
.dw 0xBBDF ;081C
.dw 0x9621 ;081D
.dw 0x9508 ;081E
.dw 0xDFF6 ;081F
.dw 0x9AE0 ;0820
.dw 0x98E0 ;0821
.dw 0xB22D ;0822
.dw 0x9508 ;0823
.dw 0xDFFA ;0824
.dw 0x922D ;0825
.dw 0x952A ;0826
.dw 0xF7E1 ;0827
.dw 0x9508 ;0828
.dw 0x0003 ;0829
.dw 0x2DAA ;082A
.dw 0x2DBB ;082B
.dw 0x2DCC ;082C
.dw 0x2DDD ;082D
.dw 0x2D2E ;082E
.dw 0xCFF4 ;082F
.dw 0x6D58 ;0830
.dw 0x7469 ;0831
.dw 0x6520 ;0832
.dw 0x7272 ;0833
.dw 0x726F ;0834
.dw 0x0000 ;0835
.equ    max_nch = 64            
.equ    ebuf_len = 32           
.equ    buf_len = 48            
.equ my_ip = 96	; data
.equ my_ether = 100	; data
.equ nch = 106	; data
.equ inbuf = 107	; data
.equ ready = 171	; data
.equ putcok = 172	; data
.equ putc_b = 173	; data
.equ nelog = 174	; data
.equ neon = 175	; data
.equ buf = 176	; data
.equ ebuf = 224	; data
.equ pcode_debug_flag = 256	; data
.equ network_init = 14	; export

.equ isa_out = 21	; export        ;
.equ isa_in = 42	; export  ;
.equ network = 86	; export

.equ ne_rstart = 99	; export

.equ ne_wstartx = 166	; export

.equ SM_RSTART_PG = 0x46        
.equ SM_RSTOP_PG  = 0x60        
.equ sm_tstart_pg = 0x40        
.equ next_packet = 257	; data
.equ save_curr = 258	; data
.equ sm_rstop_ptr = 259	; data
.equ rcv_ovr_resend = 260	; data
.equ plongpause = 352	; pcode_routine 0
.equ curr_recv = 261	; data
.equ ovr_pkts = 262	; data
.equ rcv_hdr = 263	; data
.equ chkacc = 281	; data
.equ chklen = 283	; data
.equ chkaddr = 285	; data
.equ icmp_id = 287	; data
.equ boardlen = 289	; data
.equ boardaddr = 290	; data
.equ data_addr = 292	; data
.equ data_len = 294	; data
.equ arp_requests = 296	; data
.equ ip_header_1 = 771	; export

.equ xmit_page = 298	; data
.equ pcode_sp = 299	; data
.equ pcode_stack = 301	; data
.equ pcode_stack_end = 311	; data
.equ udp_checksum = 812	; export

.equ board_pkts = 311	; data
.equ tcp_send_seq = 312	; data
.equ ppushwi = 1105	; pcode_routine 1
.equ ppushn = 1111	; pcode_routine 2
.equ ppopw = 1126	; pcode_routine 1
.equ ppopn = 1130	; pcode_routine 2
.equ pprint = 1142	; pcode_routine 1
.equ pprintv = 1144	; pcode_routine   2
.equ pshnw = 1182	; pcode_routine 2
.equ pprintb = 1208	; pcode_routine 3
.equ pprinta = 1220	; pcode_routine 3
.equ pprintt = 1232	; pcode_routine 3
.equ pprintr = 1237	; pcode_routine 3
.equ px2s = 1269	; pcode_routine 3
.equ pr2s = 1273	; pcode_routine 3
.equ pcmpn = 1290	; pcode_routine 3
.equ paddn = 1304	; pcode_routine 3
.equ subn = 1310	; pcode_routine 3
.equ pjumpne = 1339	; pcode_routine 1
.equ pjumpeq = 1343	; pcode_routine 1
.equ pjumplo = 1347	; pcode_routine 1
.equ pi2x = 1351	; pcode_routine 2
.equ ps2x = 1359	; pcode_routine 3
.equ pz2x = 1375	; pcode_routine 2
.equ pr2x = 1384	; pcode_routine 3
.equ xmit_frame = 1471	; pcode_routine 1
.equ porwi = 1478	; pcode_routine 2
.equ pcomw = 1483	; pcode_routine 1
.equ pxorwi = 1489	; pcode_routine 2
.equ set_pcode_flags = 1501	; export

.equ r10tor0 = 1505	; export

.equ pcmpwi = 1510	; pcode_routine 2
.equ pcmpbi = 1515	; pcode_routine 2
.equ pincw = 1519	; pcode_routine 1
.equ pdecw = 1524	; pcode_routine 1
.equ psubwi = 1529	; pcode_routine 2
.equ paddwi = 1534	; pcode_routine 2
.equ pandwi = 1539	; pcode_routine 2
.equ pnegw = 1544	; pcode_routine 1
.equ pbitwi = 1553	; pcode_routine 2
.equ pclrw = 1558	; pcode_routine 1
.equ pmovwi = 1563	; pcode_routine 2
.equ pmovbi = 1567	; pcode_routine 2
.equ pmovb = 1572	; pcode_routine 2
.equ pmemcpy = 1576	; pcode_routine 3
.equ sram_checksum = 1591	; pcode_routine 0
.equ in_checksum = 1607	; pcode_routine 0
.equ do_bputc = 1664	; export

.equ bflush = 1721	; pcode_routine 0
.equ hexy = 1767	; export

.equ phexbi = 1774	; pcode_routine 1
.equ do_hexb = 1776	; export

.equ pcrlf = 1797	; pcode_routine 0
.equ do_crlf = 1798	; export

.equ pspace = 1805	; pcode_routine 0
.equ do_space = 1806	; export

.equ pputcb = 1811	; pcode_routine 1
.equ pputc = 1816	; pcode_routine 1
.equ pf2x = 1819	; pcode_routine 3
.equ do_outstr = 1835	; export

.equ do_outstrs = 1858	; export

.equ do_putchar = 1865	; export

.equ pcode_sreg = 316	; data
.equ pcode_init = 1875	; export

.equ pret = 1885	; pcode_routine   0
.equ pcall = 1899	; pcode_routine 1
.equ pcode = 1918	; export

.equ pjump = 2046	; pcode_routine 1
.equ pwreebi = 2050	; pcode_routine 2
.equ wreebi = 2054	; export

.equ ps2ee = 2059	; pcode_routine 3
.equ s2ee = 2065	; export

.equ rdeeb = 2079	; export

.equ ee2s = 2084	; export

.equ pee2s = 2089	; pcode_routine 3
user_code:                  
.equ sram_end = 317	; data
.equ user_data = 317	; data
;_;_import_serial_putchar
;_;_import_tcp_recv
;_;_import_seeprom_read
;_;_import_udp
;_;_import_seeprom_read_bytes
;_;_import_unknown_ipaddr
#line 1 "userpre.h"
;-------------------------------------------------------------------------
; Copyright (c) 1999 Steven Freyder, David Helland, and Bruce D. Lightner.
; Use subject to licensing restrictions described in "PICOWEB SERVER
; SOFTWARE LICENSE AGREEMENT DATED JULY 14, 1999" (See file LICENSE.txt).
;-------------------------------------------------------------------------

#line 1 "8515def.inc" 1
;***************************************************************************
;* A P P L I C A T I O N   N O T E   F O R   T H E   A V R   F A M I L Y
;* 
;* Number		:AVR000
;* File Name		:"8515def.inc"
;* Title		:Register/Bit Definitions for the AT90S8515
;* Date                 :97.12.11
;* Version              :1.20
;* Support telephone	:+47 72 88 87 20 (ATMEL Norway)
;* Support fax		:+47 72 88 87 18 (ATMEL Norway)
;* Support E-mail	:avr@atmel.com
;* Target MCU		:AT90S8515
;*
;* DESCRIPTION
;* When including this file in the assembly program file, all I/O register	
;* names and I/O register bit names appearing in the data book can be used.
;* In addition, the six registers forming the three data pointers X, Y and
;* Z have been assigned names XL - ZH. Highest RAM address for Internal 
;* SRAM is also defined 
;*
;* The Register names are represented by their hexadecimal address.
;* 
;* The Register Bit names are represented by their bit number (0-7).
;* 
;* Please observe the difference in using the bit names with instructions
;* such as "sbr"/"cbr" (set/clear bit in register) and "sbrs"/"sbrc" 
;* (skip if bit in register set/cleared). The following example illustrates
;* this:
;* 
;* in	r16,PORTB		;read PORTB latch
;* sbr	r16,(1<<PB6)+(1<<PB5)	;set PB6 and PB5 (use masks, not bit#)
;* out  PORTB,r16		;output to PORTB
;*
;* in	r16,TIFR		;read the Timer Interrupt Flag Register
;* sbrc	r16,TOV0		;test the overflow flag (use bit#)
;* rjmp	TOV0_is_set		;jump if set
;* ...				;otherwise do something else
;***************************************************************************

;***** Specify Device
.device AT90S8515

;***** I/O Register Definitions
.equ	SREG	=$3f
.equ	SPH	=$3e
.equ	SPL	=$3d
.equ	GIMSK	=$3b
.equ	GIFR	=$3a
.equ	TIMSK	=$39
.equ	TIFR	=$38
.equ	MCUCR	=$35
.equ	TCCR0	=$33
.equ	TCNT0	=$32
.equ	TCCR1A	=$2f
.equ	TCCR1B	=$2e
.equ	TCNT1H	=$2d
.equ	TCNT1L	=$2c
.equ	OCR1AH	=$2b
.equ	OCR1AL	=$2a
.equ	OCR1BH	=$29
.equ	OCR1BL	=$28
.equ	ICR1H	=$25
.equ	ICR1L	=$24
.equ	WDTCR	=$21
.equ	EEARH	=$1f
.equ	EEARL	=$1e
.equ	EEDR	=$1d
.equ	EECR	=$1c
.equ	PORTA	=$1b
.equ	DDRA	=$1a
.equ	PINA	=$19
.equ	PORTB	=$18
.equ	DDRB	=$17
.equ	PINB	=$16
.equ	PORTC	=$15
.equ	DDRC	=$14
.equ	PINC	=$13
.equ	PORTD	=$12
.equ	DDRD	=$11
.equ	PIND	=$10
.equ	SPDR	=$0f
.equ	SPSR	=$0e
.equ	SPCR	=$0d
.equ	UDR	=$0c
.equ	USR	=$0b
.equ	UCR	=$0a
.equ	UBRR	=$09
.equ	ACSR	=$08


;***** Bit Definitions
.equ	INT1	=7
.equ	INT0	=6

.equ	TOIE1	=7
.equ	OCIE1A	=6
.equ	OCIE1B	=5
.equ	TICIE1	=3
.equ	TOIE0	=1

.equ	TOV1	=7
.equ	OCF1A	=6
.equ	OCF1B	=5
.equ	ICF1	=3
.equ	TOV0	=1

.equ	SRE	=7
.equ	SRW	=6
.equ	SE	=5
.equ	SM	=4
.equ	ISC11	=3
.equ	ISC10	=2
.equ	ISC01	=1
.equ	ISC00	=0

.equ	COM1A1	=7
.equ	COM1A0	=6
.equ	COM1B1	=5
.equ	COM1B0	=4
.equ	PWM11	=1
.equ	PWM10	=0

.equ	ICNC1	=7
.equ	ICES1	=6
.equ	CTC1	=3
.equ	CS12	=2
.equ	CS11	=1
.equ	CS10	=0

.equ	WDTOE	=4
.equ	WDE	=3
.equ	WDP2	=2
.equ	WDP1	=1
.equ	WDP0	=0

.equ	EEMWE	=2
.equ	EEWE	=1
.equ	EERE	=0

.equ	PA7	=7
.equ	PA6	=6
.equ	PA5	=5
.equ	PA4	=4
.equ	PA3	=3
.equ	PA2	=2
.equ	PA1	=1
.equ	PA0	=0

.equ	DDA7	=7
.equ	DDA6	=6
.equ	DDA5	=5
.equ	DDA4	=4
.equ	DDA3	=3
.equ	DDA2	=2
.equ	DDA1	=1
.equ	DDA0	=0

.equ	PINA7	=7
.equ	PINA6	=6
.equ	PINA5	=5
.equ	PINA4	=4
.equ	PINA3	=3
.equ	PINA2	=2
.equ	PINA1	=1
.equ	PINA0	=0

.equ	PB7	=7
.equ	PB6	=6
.equ	PB5	=5
.equ	PB4	=4
.equ	PB3	=3
.equ	PB2	=2
.equ	PB1	=1
.equ	PB0	=0

.equ	DDB7	=7
.equ	DDB6	=6
.equ	DDB5	=5
.equ	DDB4	=4
.equ	DDB3	=3
.equ	DDB2	=2
.equ	DDB1	=1
.equ	DDB0	=0

.equ	PINB7	=7
.equ	PINB6	=6
.equ	PINB5	=5
.equ	PINB4	=4
.equ	PINB3	=3
.equ	PINB2	=2
.equ	PINB1	=1
.equ	PINB0	=0

.equ	PC7	=7
.equ	PC6	=6
.equ	PC5	=5
.equ	PC4	=4
.equ	PC3	=3
.equ	PC2	=2
.equ	PC1	=1
.equ	PC0	=0

.equ	DDC7	=7
.equ	DDC6	=6
.equ	DDC5	=5
.equ	DDC4	=4
.equ	DDC3	=3
.equ	DDC2	=2
.equ	DDC1	=1
.equ	DDC0	=0

.equ	PINC7	=7
.equ	PINC6	=6
.equ	PINC5	=5
.equ	PINC4	=4
.equ	PINC3	=3
.equ	PINC2	=2
.equ	PINC1	=1
.equ	PINC0	=0

.equ	PD7	=7
.equ	PD6	=6
.equ	PD5	=5
.equ	PD4	=4
.equ	PD3	=3
.equ	PD2	=2
.equ	PD1	=1
.equ	PD0	=0

.equ	DDD7	=7
.equ	DDD6	=6
.equ	DDD5	=5
.equ	DDD4	=4
.equ	DDD3	=3
.equ	DDD2	=2
.equ	DDD1	=1
.equ	DDD0	=0

.equ	PIND7	=7
.equ	PIND6	=6
.equ	PIND5	=5
.equ	PIND4	=4
.equ	PIND3	=3
.equ	PIND2	=2
.equ	PIND1	=1
.equ	PIND0	=0

.equ	RXC	=7
.equ	TXC	=6
.equ	UDRE	=5
.equ	FE	=4
.equ	OR	=3

.equ	SPIE	=7
.equ	SPE	=6
.equ	DORD	=5
.equ	MSTR	=4
.equ	CPOL	=3
.equ	CPHA	=2
.equ	SPR1	=1
.equ	SPR0	=0

.equ	SPIF	=7
.equ	WCOL	=6

.equ	RXCIE	=7
.equ	TXCIE	=6
.equ	UDRIE	=5
.equ	RXEN	=4
.equ	TXEN	=3
.equ	CHR9	=2
.equ	RXB8	=1
.equ	TXB8	=0

.equ	ACD	=7
.equ	ACO	=5
.equ	ACI	=4
.equ	ACIE	=3
.equ	ACIC	=2
.equ	ACIS1	=1
.equ	ACIS0	=0

.def	XL	=r26
.def	XH	=r27
.def	YL	=r28
.def	YH	=r29
.def	ZL	=r30
.def	ZH	=r31

.equ 	RAMEND =$25F	;Last On-Chip SRAM Location

.equ	INT0addr=$001	;External Interrupt0 Vector Address
.equ	INT1addr=$002	;External Interrupt1 Vector Address
.equ	ICP1addr=$003	;Input Capture1 Interrupt Vector Address
.equ	OC1Aaddr=$004	;Output Compare1A Interrupt Vector Address
.equ	OC1Baddr=$005	;Output Compare1B Interrupt Vector Address
.equ	OVF1addr=$006	;Overflow1 Interrupt Vector Address
.equ	OVF0addr=$007	;Overflow0 Interrupt Vector Address
.equ	SPIaddr =$008	;SPI Interrupt Vector Address
.equ	URXCaddr=$009	;UART Receive Complete Interrupt Vector Address
.equ	UDREaddr=$00a	;UART Data Register Empty Interrupt Vector Address
.equ	UTXCaddr=$00b	;UART Transmit Complete Interrupt Vector Address
.equ	ACIaddr =$00c	;Analog Comparator Interrupt Vector Address
#line 7 "userpre.h" 2

#line 1 "sdfmac.inc" 1
;-------------------------------------------------------------------------
; Copyright (c) 1999 Steven Freyder, David Helland, and Bruce D. Lightner.
; Use subject to licensing restrictions described in "PICOWEB SERVER
; SOFTWARE LICENSE AGREEMENT DATED JULY 14, 1999" (See file LICENSE.txt).
;-------------------------------------------------------------------------

.macro stxi
    ldi w,@0
    st x+,w
.endmacro

.equ pcode_signature = 0        ;;; top 3 bits now ind. disable flags
.equ pcode_arg_mask = 3
.equ NO_P1_IND = 0x8000
.equ NO_P2_IND = 0x4000
.equ NO_P3_IND = 0x2000

.macro andwi
    andi @0l,low(@1)
    andi @0h,high(@1)
.endmacro

.macro pcode_routine
    .dw @0|pcode_signature
.endmacro

.macro label
.set @0 = pc
.endmacro

.macro coroutine
    pop zh
    pop zl
.endm

.macro ldsw
    lds @0l,@1
    lds @0h,@1+1
.endmacro

.macro stsw
    sts @0,@1l
    sts @0+1,@1h
.endmacro

.macro pushw
    push @0h
    push @0l
.endmacro

.macro popw
    pop @0l
    pop @0h
.endmacro

.macro shrw
    lsr @0h
    ror @0l
.endmacro

.macro shlw
    lsl @0l
    rol @0h
.endmacro

.macro tstb
    mov w,@1
    and w,@0
.endmacro

.macro tstbi
    ldi w,@1
    and w,@0
.endmacro

.macro cmpw
    cp @0l,@1l
    cpc @0h,@1h
.endmacro

.macro cmpwi
    cpi @0l,low(@1)
    ldi w,high(@1)
    cpc @0h,w
.endmacro

.macro  coroutine_call
    pop zh
    pop zl
    icall
.endmacro

.macro coroutine_done
    pop zh
    pop zl
.endmacro

.macro coroutine_return
    push    zl
    push zh
    ret
.endmacro

.macro coroutine_setup
    push    zl
    push    zh
.endmacro

.macro putchar
	ldi	ch,@0
	rcall do_putchar
.endmacro

.macro hexb
    rcall do_hexb
.endmacro

.macro space
    rcall do_space
.endmacro

.macro crlf
    rcall do_crlf
.endmacro

.macro addwi
    ldi w,low(@1)
    add @0l,w
    ldi w,high(@1)
    adc @0h,w
.endmacro

.macro addw
    add @0l,@1l
    adc @0h,@1h
.endmacro

.macro subwi
    ldi w,low(@1)
    sub @0l,w
    ldi w,high(@1)
    sbc @0h,w
.endmacro

.macro subw
    sub @0l,@1l
    sbc @0h,@1h
.endmacro

.macro movwi
	ldi	@0l,low(@1)
	ldi	@0h,high(@1)
.endmacro

.macro clrw
    clr @0l
    clr @0h
.endmacro

.macro decw
    subi @0l,1
    sbci @0h,0
.endmacro

.macro incw
    subi @0l,-1
    sbci @0h,-1
.endmacro

.macro ldsbw
	lds	@0l,@1
    clr @0h
.endmacro

.macro movw
    mov @0l,@1l
    mov @0h,@1h
.endmacro

.macro outstr
    rcall do_outstr
	.dw	(@0*2)
.endmacro

.macro hexy
    rcall hexy
.endmacro

.macro outstrs
	ldi	yl,low(@0)
	ldi	yh,high(@0)
    rcall do_outstrs
.endmacro

.macro setport
    ldi r16,@1
    mov i0,r16
    ldi r16,@0
    rcall isa_out
.endmacro

.macro isa_out
    rcall   isa_out
.endmacro

.def r0l =r0
.def r0h =r1
.def r1l =r1
.def i0 =r2
.def r1h =r2
.def r2l =r2
.def i1 =r3
.def r2h =r3
.def r3l =r3
;.def i2 =r4
;.def r3h =r4
;.def r4l =r4
;.def r4h =r5
;.def r5l =r5
.def pl=r4
.def ph=r5  ; pcode PC low, high
;.def r5h =r6
.def r6l =r6
.def r6h =r7
.def r7l =r7
.def r7h =r8
.def r8l =r8
.def r8h =r9
.def r9l =r9
.def r9h =r10
.def r10l =r10
.def r10h =r11
.def r11l =r11
.def r11h =r12
.def r12l =r12
.def r12h =r13
.def r13l =r13
.def r13h =r14
.def r14l =r14
.def r14h =r15
.def r15l =r15
.def r15h =r16
.def r16l =r16
.def r16h =r17
.def r17l =r17
.def r17h =r18
.def r18l =r18
.def r18h =r19
.def r19l =r19
.def r19h =r20
.def r20l =r20
.def r20h =r21
.def r21l =r21
.def r21h =r22
.def r22l =r22
.def r22h =r23
.def r23l =r23
.def r23h =r24
;; reserved for macros.
.def r24l = r24
.def r24h = r25
.def ch = r25 ; for putchar

;.def wl   =r24
.def w    =r25
;.def wh   =r25
;.def w1   =r25

.def r25h =r26
.def r26l =r26
.def xl  =r26
.def r26h =r27
.def r27l =r27
.def xh  =r27

.def r27h =r28
.def r28l =r28
.def yll  =r28
.def r28h =r29
.def r29l =r29
.def ylh  =r29

.def r29h =r30
.def r30l =r30
.def zl  =r30
.def r30h =r31
.def r31l =r31
.def zh  =r31

.macro asm
.dw 0
.endmacro

.macro pend
.dw 0
.endmacro

.macro pbegin
rcall pcode
.endmacro

.macro export
.endmacro

.macro f2x_checksum
    add xl,@0l
    adc xh,@0h
    clr @1
    adc xl,@1
    adc xh,@1
.endmacro

.equ XX = 0x8000                        ; eXtended operand fetching
.equ XW = 0x4000                        ; word mode, else byte
.equ XS = 0x2000                        ; swap bytes


.device AT90S8515       ;Prohibits use of non-implemented instructions

.equ    stackend = ramend

#line 8 "userpre.h" 2

#line 1 "8390.inc" 1
; The EN registers - the DS8390 chip registers 
; There are two (really 3) pages of registers in the chip. You select 
; which page you want, then address them at offsets 00-0F from base. 
; The chip command register (EN_CCMD) appears in both pages. 
; EN_OFF is the offset from the board's base register to the EN registers. 
;
.equ eaddr_len = 6 ;               bytes in an ether address 
;
.equ en_ccmd = 0x000 ;      Chip's command register 
;
; Page 0 
;
.equ en0_cldalo = 0x001 ;  	 Low byte of current local dma addr  RD 
.equ en0_startpg = 0x001 ;  	 Starting page of ring bfr WR 
.equ en0_cldahi = 0x002 ;  	 High byte of current local dma addr  RD 
.equ en0_stoppg = 0x002 ;  	 Ending page +1 of ring bfr WR 
.equ en0_boundary = 0x003 ;  	 Boundary page of ring bfr RD WR 
.equ en0_tsr = 0x004 ;  	 Transmit status reg RD 
.equ en0_tpsr = 0x004 ;  	 Transmit starting page WR 
.equ en0_ncr = 0x005 ;  	 Number of collision reg RD 
.equ en0_tcntlo = 0x005 ;  	 Low  byte of tx byte count WR 
.equ en0_fifo = 0x006 ;  	 FIFO RD 
.equ en0_tcnthi = 0x006 ;  	 High byte of tx byte count WR 
.equ en0_isr = 0x007 ;  	 Interrupt status reg RD WR 
.equ en0_crdalo = 0x008 ;  	 low byte of current remote dma address RD 
.equ en0_rsarlo = 0x008 ;  	 Remote start address reg 0 
.equ en0_crdahi = 0x009 ;  	 high byte of current remote dma address RD 
.equ en0_rsarhi = 0x009 ;  	 Remote start address reg 1 
.equ en0_rcntlo = 0x00a ;  	 Remote byte count reg WR 
.equ en0_rcnthi = 0x00b ;  	 Remote byte count reg WR 
.equ en0_rsr = 0x00c ;  	 rx status reg RD 
.equ en0_rxcr = 0x00c ;  	 RX control reg WR 
.equ en0_txcr = 0x00d ;  	 TX control reg WR 
.equ en0_counter0 = 0x00d ;  	 Rcv alignment error counter RD 
.equ en0_dcfg = 0x00e ;  	 Data configuration reg WR 
.equ en0_counter1 = 0x00e ;  	 Rcv CRC error counter RD 
.equ en0_imr = 0x00f ;  	 Interrupt mask reg WR 
.equ en0_counter2 = 0x00f ;  	 Rcv missed frame error counter RD 
;
; Page 1 
;
.equ en1_phys = 0x001 ;  	 This board's physical enet addr RD WR 
.equ en1_curpag = 0x007 ;  	 Current memory page RD WR 
.equ en1_mult = 0x008 ;  	 Multicast filter mask array (8 bytes) RD WR 
;
; Chip commands in EN_CCMD 
.equ enc_stop = 0x001 ;  	 Stop the chip 
.equ enc_start = 0x002 ;  	 Start the chip 
.equ enc_trans = 0x004 ;  	 Transmit a frame 
.equ enc_rread = 0x008 ;  	 remote read 
.equ enc_rwrite = 0x010 ;  	 remote write 
.equ enc_nodma = 0x020 ;  	 No remote DMA used on this card 
.equ enc_page0 = 0x000 ;  	 Select page 0 of chip registers 
.equ enc_page1 = 0x040 ;  	 Select page 1 of chip registers 
.equ enc_page2 = 0x080 ;         page 2
.equ enc_page3 = 0x0c0 ;         page 3 (Realtek RTL8019AS chip)
;
; Commands for EN0_RXCR - RX control reg 
.equ enrxcr_crc = 0x001 ;  	 Save error pkts 
.equ enrxcr_runt = 0x002 ;  	 Accept runt pkt 
.equ enrxcr_bcst = 0x004 ;  	 Accept broadcasts 
.equ enrxcr_multi = 0x008 ;  	 Multicast (if pass filter) 
.equ enrxcr_promp = 0x010 ;  	 Promiscuous physical addresses 
.equ enrxcr_mon = 0x020 ;  	 Monitor mode (no packets rcvd) 
;
; Bits in EN0_TXCR - transmit control reg 
.equ entxcr_crc = 0x001 ;  		 inhibit CRC, do not append crc 
.equ entxcr_loop = 0x002 ;  		 Set loopback mode 
.equ entxcr_lb01 = 0x006 ;  		 encoded loopback control 
.equ entxcr_atd = 0x008 ;  		 auto tx disable 
.equ entxcr_ofst = 0x010 ;  		 collision offset enable 
;
; Bits in EN0_DCFG - Data config register 



.equ endcfg_wts = 0x001 ;  	 word transfer mode selection 

.equ endcfg_bos = 0x002 ;  	 byte order selection 
.equ endcfg_las = 0x004 ;  	 long addr selection 
.equ endcfg_bms = 0x008 ;  	 burst mode selection 
.equ endcfg_arm = 0x010 ;  	 autoinitialize remote 
.equ endcfg_ft00 = 0x000 ;  	 burst length selection 
.equ endcfg_ft01 = 0x020 ;  	 burst length selection 
.equ endcfg_ft10 = 0x040 ;  	 burst length selection 
.equ endcfg_ft11 = 0x060 ;  	 burst length selection 
;
; Bits in EN0_ISR - Interrupt status register 
.equ enisr_rx = 0x001 ;  	 Receiver, no error 
.equ enisr_tx = 0x002 ;  	 Transmitter, no error 
.equ enisr_rx_err = 0x004 ;  	 Receiver, with error 
.equ enisr_tx_err = 0x008 ;  	 Transmitter, with error 
.equ enisr_over = 0x010 ;  	 Receiver overwrote the ring 
.equ enisr_counters = 0x020 ;  	 Counters need emptying 
.equ enisr_rdc = 0x040 ;  	 remote dma complete 
.equ enisr_reset = 0x080 ;  	 Reset completed 
;
.equ enisr_all = 0x03f ;  	 Interrupts we will enable 
;
; Bits in received packet status byte and EN0_RSR 
.equ enrsr_rxok = 0x001 ;  	 Received a good packet 
.equ enrsr_crc = 0x002 ;  	 CRC error 
.equ enrsr_fae = 0x004 ;  	 frame alignment error 
.equ enrsr_fo = 0x008 ;  	 FIFO overrun 
.equ enrsr_mpa = 0x010 ;  	 missed pkt 
.equ enrsr_phy = 0x020 ;  	 physical/multicase address 
.equ enrsr_dis = 0x040 ;  	 receiver disable. set in monitor mode 
.equ enrsr_def = 0x080 ;  	 deferring 
;
; Bits in EN0_TSR -  TX status reg 
;
.equ entsr_ptx = 0x001 ;  	 Packet transmitted without error 
.equ entsr_dfr = 0x002 ;  	 non deferred tx 
.equ entsr_coll = 0x004 ;  	 Collided at least once 
.equ entsr_coll16 = 0x008 ;  	 Collided 16 times and was dropped 
.equ entsr_crs = 0x010 ;  	 carrier sense lost 
.equ entsr_fu = 0x020 ;  	 TX FIFO Underrun 
.equ entsr_cd = 0x040 ;  	 collision detect heartbeat 
.equ entsr_owc = 0x080 ;  	 out of window collision 
;
; Description of header of each packet in receive area of memory 
;
.equ en_rbuf_stat = 0 ;  	 Received frame status 
.equ en_rbuf_nxt_pg = 1 ;  	 Page after this frame 
.equ en_rbuf_size_lo = 2 ;  	 Length of this frame 
.equ en_rbuf_size_hi = 3 ;  	 Length of this frame 
.equ en_rbuf_nhdr = 4 ;  	 Length of above header area 
;
#line 9 "userpre.h" 2

.dseg
.org user_data
.cseg
.org user_code
#define BSWAP(v)  ((low(v)<<8)|high(v))

.macro show_ether
	ldi r17,6
    ldi xl,my_ether&0xff
    ldi xh,(my_ether>>8)&0xff
.set x = pc
	ld i0,x+
	rcall do_hexb
	dec r17
	brne x
.endmacro

.macro picoweb_init
;
; picoweb.inc - picoweb initialization static code which becomes
; part of the "picoweb_init" macro.
;
	rcall pcode_init                ; initialize pcode engine   **PICOWEB
	rcall network_init              ;                   **PIOWEB
.endmacro

.macro stack_init

; initialize SP to top of SRAM.

	ldi     w,low(stackend)
	out     spl,w
	ldi     w,high(stackend)
	out     sph,w
.endmacro

.macro watchdog_init
#if defined(PKT_WATCHDOG_MAX)
.dseg
pkt_wdogs:  .byte 1
.cseg
#ifdef ENABLE_WATCHDOG
	ldi r16,0x0F    ; enable watchdog timer (~2 sec.)
	out wdtcr,r16
	wdr             ; reset watchdog timer
#endif
#ifdef PKT_WATCHDOG_MAX
	sts pkt_wdog_cnt,r17    ; zero packet watchdog counter
#endif
#endif
.endmacro

.macro network_watchdog
#ifdef PKT_WATCHDOG_MAX
	lds r17,neon
	or r17,r17
	breq no_pkt_wdog

	lds r17,pkt_wdog_cnt    ; bump/check net watchdog
	inc r17
	sts pkt_wdog_cnt,r17
	cpi r17,PKT_WATCHDOG_MAX
	brne no_pkt_wdog

#ifdef PKT_WATCHDOG_DEBUG
	lds r17,pkt_wdogs       ; bump debug counter
	inc r17
	sts pkt_wdogs,r17
#endif
	rcall network_init      ; reset network chip

	clr r17
	sts pkt_wdog_cnt,r17    ; zero packet watchdog counter
no_pkt_wdog:
#endif
    .endmacro
;-------------------------------------------------------------------------
; Copyright (c) 1999 Steven Freyder, David Helland, and Bruce D. Lightner.
; Use subject to licensing restrictions described in "PICOWEB SERVER
; SOFTWARE LICENSE AGREEMENT DATED JULY 14, 1999" (See file LICENSE.txt).
;-------------------------------------------------------------------------

#if !defined(TCPIP_INC_INCLUDED)
#define TCPIP_INC_INCLUDED
#define _FIN     0x0001
#define _SYN     0x0002
#define _RST     0x0004
#define _PUSH    0x0008
#define _ACK     0x0010
#define _DO_B(x)  (((x/4)+5)<<12)
#define _DO      _DO_B(0)

#define ETH_DEST 0
#define ETH_SRC ETH_DEST+6
#define ETH_PT ETH_SRC+6
#define IPH  ETH_PT+2
#define IP_HVTOS   IPH+0
#define IP_LEN     IPH+2
#define IP_ID      IPH+4
#define IP_FFO     IPH+6
#define IP_TTLP    IPH+8
#define IP_CHKSUM  IPH+10
#define IP_SRCADDR IPH+12
#define IP_DSTADDR IPH+16
#define IP_HEADER_LEN  20
#define IPD IPH+IP_HEADER_LEN

#define TCP_HEADER  IPD+0
#define TCP_SP      IPD+0
#define TCP_DP      IPD+2
#define TCP_SEQ     IPD+4
#define TCP_ACK     IPD+8
#define TCP_FLAGS   IPD+12
#define TCP_WIN     IPD+14
#define TCP_CHKSUM  IPD+16
#define TCP_URG     IPD+18
#define TCP_DATA    IPD+20
#define TCP_HEADER_LEN  20

#define UDP_HEADER  IPD+0
#define UDP_SP          UDP_HEADER+0
#define UDP_DP          UDP_HEADER+2
#define UDP_LEN         UDP_HEADER+4
#define UDP_CHKSUM      UDP_HEADER+6
#define UDP_DATA        UDP_HEADER+8
#define UDP_HEADER_LEN 8

#define SET_ADDL(val)      \
    .dw pmovwi,buf+4,byte4(val)|(byte3(val)<<8),pmovwi,buf+6,byte2(val)|(low(val)<<8)
#define R2X_ADDL(to,from)   \
    .dw pr2s,buf,from,4,paddn,buf,buf+4,4,ps2x,to,buf,4
#define R2X_LONG(to,from)  .dw pr2x,to,from,4
#define R2X_WORD(to,from)  .dw pr2x,to,from,2
#define	SET_IP(i,l,a,b,c,d)  .dw i,l,a|(b<<8),i,l+2,c|(d<<8)

#define BSWAP(v)  ((low(v)<<8)|high(v))

#endif



